select 'Создаём таблицы для данных... ' as ' ';

--
-- Структура таблицы `tmpMed`
--

CREATE TABLE IF NOT EXISTS `tmpMed` (
`code` varchar(5) NOT NULL COMMENT 'Код',
`FIO` varchar(50) NOT NULL COMMENT 'ФИО врача',
`speciality` varchar(5) NOT NULL COMMENT 'Специальность',
`LPU` varchar(10) NOT NULL COMMENT 'ЛПУ',
`section` varchar(5) NOT NULL COMMENT 'Отделение',
`Person_id` int(11),
`Person_type` tinyint(2) DEFAULT '0',
`OrgStructure_id` int(11),
`OrgStructure_type` tinyint(2) DEFAULT '0',
PRIMARY KEY (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
--ALTER TABLE `tmpMed` ADD FOREIGN KEY (`speciality`) REFERENCES `tmpSpeciality`(`code`) ON DELETE SET NULL;
--ALTER TABLE `tmpMed` ADD FOREIGN KEY (`Person_id`) REFERENCES `Person`(`id`) ON DELETE SET NULL;
--ALTER TABLE `tmpMed` ADD FOREIGN KEY (`OrgStructure_id`) REFERENCES `OrgStructure`(`id`) ON DELETE SET NULL;









--
-- Структура таблицы `tmpStattal`
--

CREATE TABLE IF NOT EXISTS `tmpStattal` (
`key` bigint(20) NOT NULL COMMENT 'Ключ',
`Pin` varchar(10) COMMENT 'Pin-код',
`lastName` varchar(30) NOT NULL COMMENT 'Фамилия',
`firstName` varchar(30) COMMENT 'Имя',
`patrName` varchar(30) COMMENT 'Отчество',
`sex` tinyint(1) COMMENT 'Пол',
`birthDate` date COMMENT 'Дата рождения',
`howOld` tinyint(3) COMMENT 'Лет',
`category` tinyint(1) COMMENT 'Категория',
`work` tinyint(1) COMMENT 'Работает',
`area` tinyint(4) COMMENT 'Район',
`street` varchar(10) COMMENT 'Улица',
`house` varchar(10)  COMMENT 'Дом',
`korpus` varchar(10) COMMENT 'Корпус',
`flat` varchar(10) COMMENT 'Кв.',
`documentType` tinyint(4) COMMENT 'Документ',
`documentSerial` varchar(8) COMMENT 'Серия документа',
`documentNumber` varchar(16) COMMENT 'Номер документа',
`SMO` varchar(10) COMMENT 'СМО',
`policySerial` varchar(8) COMMENT 'Серия полиса',
`policyNumber` varchar(16) COMMENT 'Номер полиса',
`pay` tinyint(1) COMMENT 'Оплата',
`LPU` varchar(10) COMMENT 'ЛПУ',
`orgStructure` varchar(5) COMMENT 'Участок',
`eventType` tinyint(1) COMMENT 'Тип',
`territory` varchar(5) COMMENT 'Территория',
`region` varchar(10) COMMENT 'Регион',
`vrach` varchar(5) COMMENT 'Врач {med.code}',
`speciality` tinyint(4) COMMENT 'Специальность вреча',
`purpose` tinyint(1) COMMENT 'Цель',
`isPrimary` tinyint(1) COMMENT 'признак первичности (1 - первичный, 2 - повторный)',
`finished` tinyint(1) COMMENT 'Законч',
`MKB` varchar(8) COMMENT 'Диагноз',
`diseaseCharacter` tinyint(1) COMMENT 'Характер заболевания',
`dispanser` tinyint(1) COMMENT 'Диспансерный учет',
`dispanserFinished` tinyint(1) COMMENT 'Снят с учёта',
`traumaType` tinyint(2) COMMENT 'Травма (тип)',
`MKBEx` varchar(8) COMMENT 'Дополнительный диагноз',
`createDate` date COMMENT 'Дата ввода',
`createPerson` varchar(11)COMMENT 'Оператор ввода',
`eventResult` tinyint(1) COMMENT 'Исход',
`endDate` date COMMENT 'Дата',
`visitCount` tinyint(4) COMMENT 'Посещения (количество)',
`invalidType` tinyint(1) COMMENT 'Инвалидность',
`invalidGroup` tinyint(2) COMMENT 'Группа инвалидности',
`invalidDate` date COMMENT 'Дата инв.',
`flags` tinyint(4) COMMENT 'Флаги',
`accountDate` date COMMENT 'Дата счета',
`unHouse` int(10) COMMENT 'Un house',
`setOrganisation` varchar(50) COMMENT 'Направившая организация',
`healthGroup` tinyint(1)  COMMENT 'Группа здоровья ',
`TMO` varchar(10) COMMENT 'Баз.ТМО',
`education` tinyint(1) COMMENT 'Образование',
`begDate` date COMMENT 'Дата начала',
`napr` varchar(20) COMMENT 'Напр',
`number` varchar(7) COMMENT 'Номер',
`time` time COMMENT 'Время',
`zone` varchar(20) COMMENT 'Зона',
`str` varchar(20) COMMENT 'Стр',
`coding` varchar(20) COMMENT 'Шифр',
`firstVisitDate` date COMMENT 'Дополнительное поле! Дата первого визита {tmpGosop.date}',
`Client_id` int(11),
`Event_id` int(11),
`Event_type` tinyint(2) DEFAULT '0',
`Diagnostic_id` int(11),
`Diagnostic_type` tinyint(2) DEFAULT '0',
`tmpClient_id` int(11),
`tmpDiagnosis_id` int(11),
PRIMARY KEY  (`key`),
KEY ( `Client_id` , `begDate` ), -- для ускорения поиска обращений
KEY ( `tmpClient_id` ),
KEY ( `Event_id` ),
KEY(`tmpDiagnosis_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


-- Таблицу клиентов создаём из tmpStattal во избежание повторений (для приведения к нормальной форме):

--
-- Структура таблицы `tmpClient`
--

CREATE TABLE IF NOT EXISTS `tmpClient` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`Pin` varchar(10) default NULL COMMENT 'Pin-код',
`lastName` varchar(30) NOT NULL COMMENT 'Фамилия',
`firstName` varchar(30) default NULL COMMENT 'Имя',
`patrName` varchar(30) default NULL COMMENT 'Отчество',
`sex` tinyint(1) default NULL COMMENT 'Пол',
`birthDate` date default NULL COMMENT 'Дата рождения',
`howOld` tinyint(3) default NULL COMMENT 'Лет',
`category` tinyint(1) default NULL COMMENT 'Категория',
`work` tinyint(1) default NULL COMMENT 'Работает',
`territory` VARCHAR( 5 ) NOT NULL COMMENT 'Территория (г - Санкт-Петербург, о - Лен. область, и - иногородние)',
`region` VARCHAR( 10 ) default NULL COMMENT 'Регион',
`street` varchar(10) default NULL COMMENT 'Улица',
`house` varchar(10) default NULL COMMENT 'Дом',
`korpus` varchar(10) default NULL COMMENT 'Корпус',
`flat` varchar(10) default NULL COMMENT 'Кв.',
`documentType` tinyint(4) default NULL COMMENT 'Документ',
`documentSerial` varchar(8) default NULL COMMENT 'Серия документа',
`documentNumber` varchar(16) default NULL COMMENT 'Номер документа',
`SMO` varchar(10) default NULL COMMENT 'СМО',
`policySerial` varchar(8) default NULL COMMENT 'Серия полиса',
`policyNumber` varchar(16) default NULL COMMENT 'Номер полиса',
`streetCode` VARCHAR( 17 ) DEFAULT NULL COMMENT 'Дополнительное поле! Код улицы по КЛАДР',
`Client_id` int(11) default NULL,
`Client_type` tinyint(2) default '0',
`Address_id` INT( 11 ) default NULL,
`Address_type` TINYINT( 2 ) NOT NULL default '0',
`AddressHouse_id` INT( 11 ) default NULL,
`AddressHouse_type` TINYINT( 2 ) NOT NULL default '0',
PRIMARY KEY  (`id`),
KEY (`Pin`),
KEY ( `lastName` ),
KEY ( `birthDate` ),
KEY (`Client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
						  



-- Таблицу диагнозов создаём из tmpStattal во избежание повторений (для приведения к нормальной форме):

--
-- Структура таблицы `tmpDiagnosis`
--

CREATE TABLE IF NOT EXISTS `tmpDiagnosis` (
`id` int(11) NOT NULL auto_increment,
`date` date NOT NULL COMMENT 'Дата',
`person` varchar(5) default NULL COMMENT 'Врач {tmpMed.code}',
`type` varchar(8) default NULL COMMENT 'Код типа диагноза {rbDiagnosisType.code}',
`MKB` varchar(8) NOT NULL default '' COMMENT 'Диагноз',
`MKBEx` varchar(8) default NULL COMMENT 'Дополнительный диагноз',
`diseaseCharacter` tinyint(1) NOT NULL default 0 COMMENT 'Характер заболевания',
`dispanser` tinyint(1) default NULL COMMENT 'Диспансерный учёт',
`traumaType` tinyint(2) default NULL COMMENT 'Травма (тип)',
`Client_id` int(11) default NULL,
`Diagnosis_id` int(11) default NULL,
`Diagnosis_type` int(11) default NULL,
 PRIMARY KEY  (`id`),
 KEY `date` (`date`),
 KEY `Client_id` (`Client_id`),
 KEY `client_2` (`Client_id`,`date`,`MKB`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

																	      

--
-- Структура таблицы `tmpDead`
--

CREATE TABLE IF NOT EXISTS `tmpDead` (
`spravka` bigint(20) NOT NULL COMMENT 'Код справки',
`Pin` varchar(10) COMMENT 'Pin-код {tmpStattal.Pin}',
`lastName` varchar(30) NOT NULL COMMENT 'Фамилия',
`firstName` varchar(30) COMMENT 'Имя',
`patrName` varchar(30) COMMENT 'Отчество',
`sex` tinyint(4) COMMENT 'Пол',
`birthDate` varchar(10) COMMENT 'Дата рождения', -- из-за необычного формата даты приходится использовать varchar(10)
`howOld` tinyint(3) COMMENT 'Лет',
`street` varchar(10) COMMENT 'Улица',
`house` varchar(10) COMMENT 'Дом',
`korpus` varchar(10) COMMENT 'Корпус',
`flat` varchar(10) COMMENT 'Кв.',
`deadDate` varchar(10) NOT NULL COMMENT 'Дата смерти', -- из-за необычного формата даты приходится использовать varchar(10)
`MKB` varchar(8) COMMENT 'Диагноз',
`vrach` varchar(5) COMMENT 'Врач {med.code}',
`carta` tinyint(4) COMMENT 'Карта',
`createDate` varchar(10) COMMENT 'Дата ввода', -- из-за необычного формата даты приходится использовать varchar(10)
`createPerson` varchar(11)COMMENT 'Оператор',
`altMKB` varchar(8)COMMENT 'Дополнительный диагноз',
`place` varchar(20) COMMENT 'Место вскрытия',
`revelation` tinyint(1) default '0' COMMENT 'Было ли вскрытие',
`matching` tinyint(1) default '0' COMMENT 'Совпадение',
`clinMKB` varchar(8) COMMENT 'Клинический диагноз',
`patMKB` varchar(8) COMMENT 'Паталогоанатомический диагноз',
`propisan` varchar(20) COMMENT 'ПРОПИСАН',
`LPU` varchar(10) COMMENT 'ЛПУ',
`coding` varchar(20) COMMENT 'Шифр',
`orgStructure` varchar(5) COMMENT 'Участок',
`otdel` varchar(20) COMMENT 'Отдел',
`dBirthDate` DATE COMMENT 'Дополнительное поле! Дата рождения в нормальном формате',
`dDeadDate` DATE COMMENT 'Дополнительное поле! Дата смерти в нормальном формате',
`Client_id` INT( 11 ) NULL ,
`Client_type` TINYINT( 1 ) NULL ,
`Event_id` INT( 11 ) NULL ,
`Event_type` TINYINT( 1 ) NULL ,
`Action_id` INT( 11 ) NULL ,
`Action_type` TINYINT( 1 ) NULL,
PRIMARY KEY  (`spravka`),
KEY ( `dBirthDate` ),
KEY( `dDeadDate` )
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



--
-- Структура таблицы `tmpDop`
--

CREATE TABLE IF NOT EXISTS `tmpDop` (
`key` bigint(20) NOT NULL COMMENT 'Ключ {tmpStattal.key}',
`territory` varchar(5) COMMENT 'Территория',
`region` tinyint(4) COMMENT 'Район',
`district` varchar(20) COMMENT 'Район',
`street` varchar(10) COMMENT 'Улица',
`house` varchar(10) COMMENT 'Дом',
`korpus` varchar(10) COMMENT 'Корпус',
`flat` varchar(10) COMMENT 'Кв.',
`category` varchar(20) COMMENT 'Категория',
`comeCategory` varchar(20) COMMENT 'Категория допуска',
`SMO` varchar(10) COMMENT 'СМО',
`documentDate` date COMMENT 'Дата документа',
`documentWho` varchar(20) COMMENT 'Кем выдан',
`address` varchar(20) COMMENT 'Адрес',
`work` varchar(20) COMMENT 'Место работы',
`documentType` tinyint(4)COMMENT 'Документ',
`parentFIO` varchar(50) COMMENT 'ФИО родителей',
`direction` varchar(20) COMMENT 'Направление',
`documentSerial` varchar(8) COMMENT 'Серия документа',
`documentNumber` varchar(16) COMMENT 'Номер документа',
PRIMARY KEY(`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



--
-- Структура таблицы `tmpGosop`
--

CREATE TABLE IF NOT EXISTS `tmpGosop` (
`key` bigint(20) NOT NULL COMMENT 'Ключ {tmpStattal.key}',
`date` date NOT NULL COMMENT 'Дата',
`vrach` varchar(5) COMMENT 'Врач {tmpMed.code}',
`speciality` tinyint(4) COMMENT 'Специальность',
`place` tinyint(1) COMMENT 'Место',
`purpose` tinyint(1) COMMENT 'Цель',
`code` bigint(20) COMMENT 'Код  {tmpStattal.Pin}',
`Visit_id` int(11),
`Visit_type` tinyint(2) DEFAULT '0',
KEY ( `key` ),
KEY ( `code` )
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Структура таблицы `tmpHospsop`
--

CREATE TABLE IF NOT EXISTS `tmpHospsop` (
`key` bigint(20) NOT NULL COMMENT 'Ключ',
`type` tinyint(1) COMMENT 'Тип госпитализации',
`LPU` varchar(10) COMMENT 'ЛПУ, куда направлен',
`begDate` date COMMENT 'Дата госпитализации',
`endDate` date COMMENT 'Дата выписки',
`days` int(5) COMMENT 'Дней',
`vrach` varchar(5) COMMENT 'Врач',
`code` bigint(20) COMMENT 'Код {tmpStattal.key}',
PRIMARY KEY  (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




--
-- Структура таблицы `tmpNetrsop`
--

CREATE TABLE IF NOT EXISTS `tmpNetrsop` (
`key` bigint(20) NOT NULL COMMENT 'Ключ {tmpStattal.key}',
`documentType` tinyint(1) NOT NULL COMMENT 'Документ',
`documentSerial` varchar(8) COMMENT 'Серия документа',
`documentNumber` varchar(16) COMMENT 'Номер документа',
`openDate` date NOT NULL COMMENT 'Дата открытия',
`closeDate` date COMMENT 'Дата закрытия',
`blDays` int(5) COMMENT 'Дней бл',
`closeVrach` varchar(5) COMMENT 'Врач закрывший {tmpMed.code}',
`why` varchar(1) COMMENT 'Повод',
`care` tinyint(1) COMMENT 'Уход',
`sex` tinyint(1)  COMMENT 'Пол',
`howOld` int(3) COMMENT 'Лет',
`prSerial` varchar(20) COMMENT 'Серия пр',
`prNumber` varchar(20) COMMENT 'Номер пр',
`begDate` date COMMENT 'Дата начала',
`pkDays` int(5) COMMENT 'Дней пк',
`openVrach` varchar(5) COMMENT 'Врач открывший {tmpMed.code}',
`flag` tinyint(4)COMMENT 'Флаг',
`work` varchar(20)COMMENT 'Работа',
`KEK` varchar(20) COMMENT 'КЭК',
`who` varchar(20) COMMENT 'Кто выдал',
`endMKB` varchar(8)COMMENT 'Диагноз заключительный',
`key1` varchar(20) COMMENT 'Ключ 1',
`note` varchar(50) COMMENT 'Примечание',
`begMKB` varchar(8) COMMENT 'Диагноз первый',
`openPeriodKey` BIGINT( 20 ) NULL COMMENT 'Дополнительное поле! Общий период с учётом пересечений',
`begKey` BIGINT( 20 ) NULL COMMENT 'Дополнительное поле! Начало больняка',
`TempInvalid_Period_id` int(11),
`TempInvalid_Period_type` tinyint(2) DEFAULT '0',
`Client_id` INT(11),
`tmpTempInvalid_id` int(11),
PRIMARY KEY  ( `key` ),
KEY( `begKey` ),
KEY( `Client_id` ),
KEY( `openDate` )
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


-- Таблицу больняков создаём из tmpNetrsop во избежание повторений (для приведения к нормальной форме):

CREATE TABLE IF NOT EXISTS `tmpTempInvalid` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
`Client_id` INT( 11 ) NULL ,
`documentSerial` VARCHAR( 8 ) NULL ,
`documentNumber` VARCHAR( 16 ) NULL ,
`begDate` DATE NOT NULL ,
`endDate` DATE NULL ,
`TempInvalid_id` INT( 11 ) NULL ,
`TempInvalid_type` TINYINT( 2 ) NOT NULL DEFAULT '0',
PRIMARY KEY ( `id` ) 
) ENGINE = MYISAM