-- Текущая организация - та, в которой работает текущий юзер:
--select @org_id := Organisation.id from Organisation, Person
--where Person.id = @person_id
--and Person.org_id = Organisation.id;
--select @org_id := ifnull(@org_id, 0);

select 'Установление соответствий для врачей (med)...' as ' ';
-- 3 способа идентифицировать врача: (FIO, code), (FIO, speciality) и (FIO, section)

drop function if exists getSurname;
drop function if exists getFirstName;
drop function if exists getPatrName;

DELIMITER //
create function getSurname(FIO varchar(50))
returns varchar(30) deterministic
if position(' ' in FIO) != 0 then
    return concat(upper(left(FIO, 1)), lower(substr(FIO, 2, position(' ' in FIO)-2)));
else
    return concat(upper(left(FIO, 1)), lower(substr(FIO, 2, length(FIO)-2)));
end if;
//

create function getFirstName(FIO varchar(50))
returns varchar(30) deterministic
if position(' ' in FIO) != 0 then
    return substr(FIO, position(' ' in FIO)+1, 1);
else
    return '';
end if;
//

create function getPatrName(FIO varchar(50))
returns varchar(30) deterministic
if  position(' ' in FIO) != 0 then
    if substr(FIO, position(' ' in FIO)+2, 1) = '.' then
	return substr(FIO, position(' ' in FIO)+3, 1);
    else
	return substr(FIO, position(' ' in FIO)+2, 1);
    end if;
else
    return '';
end if;
//
DELIMITER;


update tmpMed
set Person_type = 0 -- неизвестно
where Person_type is null;
update tmpMed
set OrgStructure_type = 0
where OrgStructure_type is null;







update Person
left join OrgStructure on Person.orgStructure_id = OrgStructure.id
left join rbSpeciality on Person.speciality_id = rbSpeciality.id,
tmpMed
left join tmpSpeciality on tmpMed.speciality = tmpSpeciality.code
set tmpMed.Person_type = 1, -- неизвестно, есть ли соответствие
    tmpMed.Person_id = Person.id,
    tmpMed.OrgStructure_type = 1,
    tmpMed.OrgStructure_id = OrgStructure.id
where 
strcmp(getSurname(tmpMed.FIO), Person.lastName) = 0;
--and getFirstName(tmpMed.FIO) in (left(Person.firstName, 1), '')
--and getPatrName(tmpMed.FIO) in (left(Person.patrName, 1), '');

-- Под вопросом останутся только те, в которых FIO совпадает, но speciality неизвестна, а section не найдена.







update Person
left join OrgStructure on Person.orgStructure_id = OrgStructure.id
left join rbSpeciality on Person.speciality_id = rbSpeciality.id,
tmpMed
left join tmpSpeciality on tmpMed.speciality = tmpSpeciality.code
set tmpMed.Person_type = 2, -- совпадение
    tmpMed.Person_id = Person.id,
    tmpMed.OrgStructure_type = 3, -- редактируем орг. структуру??????????????
    tmpMed.OrgStructure_id = OrgStructure.id
where 
strcmp(getSurname(tmpMed.FIO), Person.lastName) = 0
--and getFirstName(tmpMed.FIO) in (left(Person.firstName, 1), '')
--and getPatrName(tmpMed.FIO) in (left(Person.patrName, 1), '')
and tmpMed.code = Person.code;






update Person
left join OrgStructure on Person.orgStructure_id = OrgStructure.id
left join rbSpeciality on Person.speciality_id = rbSpeciality.id,
tmpMed
left join tmpSpeciality on tmpMed.speciality = tmpSpeciality.code
set tmpMed.Person_type = 3, -- редактирование
    tmpMed.Person_id = Person.id,
    tmpMed.OrgStructure_type = 3,
    tmpMed.OrgStructure_id = OrgStructure.id
where tmpMed.Person_type != 2 and
(
(strcmp(getSurname(tmpMed.FIO), Person.lastName) = 0
--and getFirstName(tmpMed.FIO) in (left(Person.firstName, 1), '')
--and getPatrName(tmpMed.FIO) in (left(Person.patrName, 1), '')
and tmpSpeciality.s11code = rbSpeciality.code)
or
(strcmp(getSurname(tmpMed.FIO), Person.lastName) = 0
--and getFirstName(tmpMed.FIO) in (left(Person.firstName, 1), '')
--and getPatrName(tmpMed.FIO) in (left(Person.patrName, 1), '')
and tmpSpeciality.s11code = ''
and position(tmpMed.`section` in OrgStructure.name) != 0
)
);

select 'Обновляются записи:' as ' ';

select distinct Person.lastName, Person.firstName, Person.patrName, OrgStructure.name, rbSpeciality.name
from tmpMed
left join Person on Person.id = tmpMed.Person_id
left join OrgStructure on OrgStructure.id = tmpMed.OrgStructure_id
left join rbSpeciality on Person.speciality_id = rbSpeciality.id
where 
tmpMed.Person_type = 3;







update tmpMed
left join tmpSpeciality on tmpMed.speciality = tmpSpeciality.code
left join OrgStructure on OrgStructure.organisation_id = @org_id
			 and (tmpMed.`section` = OrgStructure.infisInternalCode
			 or position(tmpMed.`section` in OrgStructure.name) != 0)
set Person_type = 5, -- добавление
OrgStructure_id = OrgStructure.id
where not exists
(
    select * from Person
    left join OrgStructure on Person.orgStructure_id = OrgStructure.id
    left join rbSpeciality on Person.speciality_id = rbSpeciality.id
    where strcmp(getSurname(tmpMed.FIO), Person.lastName) = 0
--  and getFirstName(tmpMed.FIO) in (left(Person.firstName, 1), '')
--    and getPatrName(tmpMed.FIO) in (left(Person.patrName, 1), '')
    and (tmpMed.code = Person.code 
	or tmpSpeciality.s11code = rbSpeciality.code
        or position(tmpMed.`section` in OrgStructure.name) != 0)
);