select 'Добавление домов...' as ' ';

-- добавляем адреса только для новых пациентов, в Питере, если определена улица:
update tmpClient
set AddressHouse_type = 5
where AddressHouse_type = 0
and Client_type = 0
and streetCode is not null;

insert into AddressHouse
select distinct 0 as id,
	'0000-00-00' as createDatetime,
	@person_id as createPerson_id,
	'0000-00-00' as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	'7800000000000' as KLADRCode,
	streetCode as KLADRStreetCode,
	house as `number`,
	korpus as corpus
from tmpClient
where AddressHouse_type = 5;

update AddressHouse
set createDatetime = now(),
modifyDatetime = now()
where createDatetime = '0000-00-00'
and modifyDatetime = '0000-00-00'
and not exists (select * from Address
		where house_id = AddressHouse.id);


select 'Установка соответствий для добавленных домов...' as ' ';

update tmpClient, AddressHouse
set tmpClient.AddressHouse_id = AddressHouse.id,
tmpClient.AddressHouse_type = 2
where AddressHouse.KLADRCode = '7800000000000' and tmpClient.territory = 'г'
and AddressHouse.KLADRStreetCode = tmpClient.streetCode
and AddressHouse.`number` = tmpClient.house
and ((AddressHouse.corpus = '' and tmpClient.korpus is null)
	or AddressHouse.corpus = tmpClient.korpus)
and tmpClient.AddressHouse_type in (0, 5);


select 'Добавление адресов...' as ' ';

update tmpClient
set Address_type = 5
where Address_type = 0
and AddressHouse_type = 2;

insert into Address
select distinct 0 as id,
	'0000-00-00' as createDatetime,
	@person_id as createPerson_id,
	'0000-00-00' as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	AddressHouse_id as house_id,
	flat
from tmpClient
where Address_type = 5;

update Address
set createDatetime = now(),
modifyDatetime = now()
where createDatetime = '0000-00-00'
and modifyDatetime = '0000-00-00'
and not exists (select * from ClientAddress
		where address_id = Address.id);


select 'Установка соответствий для добавленных адресов...' as ' ';

update tmpClient, Address
set tmpClient.Address_id = Address.id,
tmpClient.Address_type = 2
where tmpClient.AddressHouse_id = Address.house_id and tmpClient.AddressHouse_type = 2
and (tmpClient.flat = Address.flat or (tmpClient.flat is null and Address.flat = ''))
and tmpClient.Address_type in (0, 5);






select 'Добавление пациентов...' as ' ';

-- добавляем пациента, если у него есть полное имя, адрес, документ и полис:
update tmpClient
left join tmpDoctype on tmpClient.documentType = tmpDoctype.svDocumentType
left join Organisation on tmpClient.SMO = Organisation.infisCode
left join Organisation_PolicySerial on Organisation_PolicySerial.organisation_id = Organisation.id
					and Organisation_PolicySerial.serial = tmpClient.policySerial
set Client_type = 5
where Client_type = 0
-- не инициалы, а полные ФИО:
and length(lastName) >= 2 
and length(firstName) >= 2 
and length(patrName) >= 2
and birthDate is not null
and tmpDoctype.rbDocumentType is not null
and documentSerial is not null
and documentNumber is not null
and Organisation_PolicySerial.policyType_id is not null
and policySerial is not null
and policyNumber is not null
and Address_type = 2;

select concat('У ', convert(count(*) using utf8), ' пациентов не указан документ, удостоверяющий личность.')
from tmpClient
where tmpClient.documentSerial is null
and tmpClient.documentNumber is null;


insert into Client
select 0 as id,
	now() as createDatetime,
	@person_id as createPerson_id,
	now() as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	concat(upper(left(lastName, 1)), lower(substr(lastName, 2))) as lastName, -- устанавливаем нормальный регистр букв
	-- неправильный регистр букв в двойных фамилиях!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	concat(upper(left(firstName, 1)), lower(substr(firstName, 2))) as firstName,
	concat(upper(left(patrName, 1)), lower(substr(patrName, 2))) as patrName,
	birthDate,
	3 - sex,
	'' as SNILS,
	NULL as bloodType_id,
	NULL as bloodDate,
	'' as bloodNotes,
	'Импортировано из SV' as notes
from tmpClient
where Client_type = 5;



select 'Установка соответствий для добавленных пациентов...' as ' ';

update tmpClient, Client
set tmpClient.Client_id = Client.id,
    tmpClient.Client_type = 2
where tmpClient.birthDate = Client.birthDate
    and tmpClient.sex != Client.sex -- в источнике мужской и женский пол нумеруются наоборот!
    and strcmp(tmpClient.lastName, Client.lastName) = 0
    and strcmp(tmpClient.firstName, Client.firstName) = 0
    and strcmp(tmpClient.patrName, Client.patrName) = 0
AND tmpClient.Client_type in (0, 5);




-- теперь устанавливаем tmpStattal.Client_id:
update tmpStattal
left join tmpClient on tmpStattal.tmpClient_id = tmpClient.id
set tmpStattal.Client_id = tmpClient.Client_id
where tmpClient.Client_type = 2;



select 'Добавление адресов, полисов и документов...' as ' ';

-- добавляем адреса в ClientAddress:
-- на каждого клиента - 1 адрес регистрации и 1 адрес проживания: --?????????????????????????
insert into ClientAddress
select 0 as id,
	now() as createDatetime,
	@person_id as createPerson_id,
	now() as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	Client_id as client_id,
	0 as `type`, 
	Address_id as address_id,
	concat('г. Санкт-Петербург, ', kladr.STREET.NAME, ' ', kladr.STREET.SOCR, ', д. ', house, if(korpus is NULL, '', concat(', корп. ', korpus)), if(flat is NULL, '', concat(', кв. ', flat))) as freeInput
from tmpClient
left join kladr.STREET on tmpClient.streetCode = kladr.STREET.CODE
where Client_type = 2
and Address_type = 2
and not exists (select * from ClientAddress
		where ClientAddress.client_id = tmpClient.Client_id
		and ClientAddress.address_id = tmpClient.Address_id
		and `type` = 0);

insert into ClientAddress
select 0 as id,
	now() as createDatetime,
	@person_id as createPerson_id,
	now() as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	Client_id as client_id,
	1 as `type`, 
	Address_id as address_id,
	concat('г. Санкт-Петербург, ', kladr.STREET.NAME, ' ', kladr.STREET.SOCR, ', д. ', house, if(korpus is NULL, '', concat(', корп. ', korpus)), if(flat is NULL, '', concat(', кв. ', flat))) as freeInput
from tmpClient
left join kladr.STREET on tmpClient.streetCode = kladr.STREET.CODE
where Client_type = 2
and Address_type = 2
and not exists (select * from ClientAddress
		where ClientAddress.client_id = tmpClient.Client_id
		and ClientAddress.address_id = tmpClient.Address_id
		and `type` = 1);


-- добавляем полиса
insert into ClientPolicy
select 0 as id,
	now() as createDatetime,
	@person_id as createPerson_id,
	now() as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	Client.id as client_id,
	Organisation.id as insurer_id,
	Organisation_PolicySerial.policyType_id,
	tmpClient.policySerial as serial,
	tmpClient.policyNumber as `number`,
	'0000-00-00' as begDate,
	NULL as endDate,
	'' as name,
	'Импортировано из SV' as note
from tmpClient
left join Client on tmpClient.Client_id = Client.id and tmpClient.Client_type = 2
left join Organisation on tmpClient.SMO = Organisation.infisCode
left join Organisation_PolicySerial on Organisation_PolicySerial.organisation_id = Organisation.id
					and Organisation_PolicySerial.serial = tmpClient.policySerial
where Client_type = 2
and not exists (select * from ClientPolicy where client_id = Client.id);

-- добавляем документы
insert into ClientDocument
select 0 as id,
	now() as createDatetime,
	@person_id as createPerson_id,
	now() as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	Client.id as client_id,
	tmpDoctype.rbDocumentType as documentType_id,
	tmpClient.documentSerial as serial,
	tmpClient.documentNumber as `number`,
	'0000-00-00' as `date`,
	'' as origin
from tmpClient
left join Client on tmpClient.Client_id = Client.id and tmpClient.Client_type = 2
left join tmpDoctype on tmpClient.documentType = tmpDoctype.svDocumentType
where Client_type = 2
and not exists (select * from ClientDocument where client_id = Client.id)
and tmpDoctype.rbDocumentType is not null; -- если тип документа неизвестен - не добавляем



drop function getStreetCode;

select 'Импорт данных о пациентах завершён.' as ' ';