
select 'Установка соответствий для диагнозов...' as ' '; 
-- устанавливаем соответствие между tmpStattal и tmpDiagnosis
-- сперва для хронических:
update tmpStattal, tmpDiagnosis
set tmpStattal.tmpDiagnosis_id = tmpDiagnosis.id
where tmpStattal.Client_id = tmpDiagnosis.Client_id -- для приведения к 3НФ надо бы создать временную таблицу tmpClient, но это не сделано из соображений эффективности
and tmpStattal.MKB = tmpDiagnosis.MKB
and tmpDiagnosis.diseaseCharacter in (2, 3, 4, 5); -- определяем хроническую болезнь по клиенту и МКБ
-- 5 считаем за 4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-- теперь для острых:
update tmpStattal, tmpDiagnosis, MKB
set tmpStattal.tmpDiagnosis_id = tmpDiagnosis.id
where tmpStattal.Client_id = tmpDiagnosis.Client_id -- для приведения к 3НФ надо бы создать временную таблицу tmpClient, но это не сделано из соображений эффективности
and tmpStattal.MKB = tmpDiagnosis.MKB
and tmpDiagnosis.MKB = MKB.DiagID
and tmpStattal.begDate >= tmpDiagnosis.`date` 
and tmpStattal.begDate <= adddate(tmpDiagnosis.`date`, interval if(MKB.duration > 0, MKB.duration, @averageDuration) day)
and tmpDiagnosis.diseaseCharacter in (0, 1); -- определяем острую болезнь по клиенту, МКБ и дате не позже duration дней после постановки диагноза

-- смотрим, какую диагностику можно добавить:
update tmpStattal, tmpDiagnosis
set tmpStattal.Diagnostic_type = 5
where tmpStattal.Diagnostic_type = 0
and tmpStattal.tmpDiagnosis_id = tmpDiagnosis.id
and tmpDiagnosis.Diagnosis_type = 2
and tmpStattal.Event_type = 2
and tmpStattal.MKB != ''; -- добавляем все непустые диагнозы для существующих обращений


select 'Установка соответствий для диагностики...' as ' '; 

update tmpStattal, Diagnostic
left join Diagnosis on Diagnostic.diagnosis_id = Diagnosis.id
set tmpStattal.Diagnostic_id = Diagnostic.id,
    tmpStattal.Diagnostic_type = 2
where tmpStattal.Event_id = Diagnostic.event_id
and tmpStattal.MKB = Diagnosis.MKB; -- если обращение и МКБ совпадают, то такой диагноз уже существует, добавлять не надо



select 'Добавление диагностики...' as ' ';

insert into Diagnostic
select 0 as id,
    now() as createDatetime,
    @person_id as createPerson_id,
    now() as modifyDatetime,
    @person_id as modifyPerson_id,
    0 as deleted,
    Event_id as event_id,
    tmpDiagnosis.Diagnosis_id as diagnosis_id,
    if(left(tmpStattal.MKB, 1) = 'Z', 7, 2) as diagnosisType_id, 
    tmpDiseaseCharacter.rbDiseaseCharacter as character_id,
    1 as stage_id, -- ????????????????????????????????
    NULL as phase_id, -- новое поле!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if(tmpStattal.dispanser in (1, 2, 3, 4, 5, 6, 7), tmpStattal.dispanser, NULL) as dispanser_id,
    0 as sanatorium, 
    0 as hospital, 
    tmpTraumaType.rbTrauma as traumaType_id,
    Person.speciality_id as speciality_id,
    Person.id as person_id,
    if(tmpStattal.healthGroup in (1, 2, 3, 4, 5, 6), tmpStattal.healthGroup, NULL) as healthGroup_id,
    tmpResults.rbResult as result_id,
    if(begDate < endDate, begDate, endDate) as setDate,
    endDate as endDate,
    'Импортировано из SV' as notes
from tmpStattal
left join tmpDiagnosis on tmpStattal.tmpDiagnosis_id = tmpDiagnosis.id
left join tmpDiseaseCharacter on tmpStattal.diseaseCharacter = tmpDiseaseCharacter.svDiseaseCharacter
left join tmpTraumaType on tmpStattal.traumaType = tmpTraumaType.svTrauma
left join tmpMed on tmpStattal.vrach = tmpMed.code
left join Person on tmpMed.Person_id = Person.id
left join tmpResults on tmpStattal.purpose = tmpResults.svPurpose and tmpStattal.eventResult = tmpResults.svResult
where tmpStattal.Diagnostic_type = 5
and tmpDiagnosis.Diagnosis_type = 2
and tmpDiagnosis.`date` != '0000-00-00' -- если дата неизвестна, не добавлять
and Person.speciality_id is not null -- если специальность неизвестна, не добавлять
and (tmpDiseaseCharacter.rbDiseaseCharacter is not null or left(tmpStattal.MKB, 1) = 'Z');

select 'У следующих врачей неизвестны специальности, поэтому диагностика не добавлена: ' as ' ';
select distinct vrach from tmpStattal
left join tmpMed on tmpStattal.vrach = tmpMed.code
left join Person on tmpMed.Person_id = Person.id
where Event_type = 2
and Person.speciality_id is null;

-- если нет диагностики, удаляем Event со всеми визитами:
update tmpStattal
left join Event on tmpStattal.Event_id = Event.id and tmpStattal.Event_type = 2
set Event_type = 4
where Event.note = 'Импортировано из SV'
and not exists (select * from Diagnostic where Diagnostic.event_id = Event.id);
DELETE FROM Event
where Event.note = 'Импортировано из SV'
and not exists (select * from Diagnostic where Diagnostic.event_id = Event.id);


select 'Установка соответствий для добавленной диагностики...' as ' '; 

update tmpStattal, Diagnostic
left join Diagnosis on Diagnostic.diagnosis_id = Diagnosis.id
set tmpStattal.Diagnostic_id = Diagnostic.id,
    tmpStattal.Diagnostic_type = 2
where tmpStattal.Event_id = Diagnostic.event_id
and tmpStattal.MKB = Diagnosis.MKB; 

select 'Импорт данных о диагнозах и диагностике завершён.' as ' ';