-- Текущая организация - та, в которой работает текущий юзер:
--select @org_id := Organisation.id from Organisation, Person
--where Person.id = @person_id
--and Person.org_id = Organisation.id;
--select @org_id := ifnull(@org_id, 0);

select 'Импорт данных о врачах (med)...' as ' ';

select 'Добавление данных о врачах...' as ' ';

select 'Добавляются записи:' as ' ';

select distinct tmpMed.FIO, tmpSpeciality.name, tmpMed.`section`
from tmpMed
left join tmpSpeciality on tmpMed.speciality = tmpSpeciality.code
where 
tmpMed.Person_type = 5;


insert into Person
select distinct
       0 as id,
       now() as createDatetime,
       @person_id as createPerson_id,
       now() as modifyDatetime,
       @person_id as modifyPerson_id,
       0 as deleted,
       tmpMed.code as code,
       '' as federalCode,
       '' as regionalCode,
       getSurname(tmpMed.FIO) as lastName,
       getFirstName(tmpMed.FIO) as firstName,
       getPatrName(tmpMed.FIO) as patrName,
       NULL as post_id,
       rbSpeciality.id as speciality_id,
       @org_id as org_id,
       OrgStructure.id as orgStructure_id,
       '' as office,
       NULL as finance_id,
       '2009-01-01' as retireDate, -- коряво!!!
       0 as ambPlan,
       0 as ambNorm,
       0 as homPlan,
       0 as homNorm,
       0 as expPlan,
       0 as expNorm,
       '' as login,
       '' as `password`,
       NULL as userProfile_id,
       1 as retired, -- уволен
       '0000-00-00' as birthDate,
       '' as birthPlace,
       0 as sex,
       '' as SNILS,
       '' as INN,
	1 as availableForExternal, -- новое поле!!!
	50 as primaryQuota, -- новое поле!!!
	25 as ownQuota, -- новое поле!!!
	25 as consultancyQuota, -- новое поле!!!
	10 as externalQuota -- новое поле!!!
from tmpMed
left join tmpSpeciality on tmpMed.speciality = tmpSpeciality.code
left join rbSpeciality on tmpSpeciality.s11code = rbSpeciality.code
left join OrgStructure on tmpMed.OrgStructure_id = OrgStructure.id
where tmpMed.Person_type = 5;

-- для добавленных устанавливаем соответствия:
update tmpMed
left join Person on tmpMed.code = Person.code
set tmpMed.Person_id = Person.id
where tmpMed.Person_type = 5;

  




select 'Обновление данных о врачах...' as ' ';

update tmpMed
left join Person on tmpMed.Person_id = Person.id
set Person.modifyDatetime = now(),
    Person.modifyPerson_id = @person_id,
    Person.code = tmpMed.code
where
tmpMed.Person_type = 3;


update tmpMed
left join Person on tmpMed.Person_id = Person.id
left join OrgStructure on tmpMed.OrgStructure_id = OrgStructure.id
set OrgStructure.modifyDatetime = now(),
    OrgStructure.modifyPerson_id = @person_id,
    OrgStructure.infisInternalCode = tmpMed.`section`
where 
tmpMed.OrgStructure_type = 3;


drop function getSurname;
drop function getFirstName;
drop function getPatrName;

select 'Импорт данных о врачах завершён.' as ' ';