
select 'Добавление документов нетрудоспособности...' as ' ';

insert into TempInvalid
select	0 as id,
	now() as createDatetime,
	@person_id as createPerson_id,
	now() as modifyDatetime,
	@person_id as modifyPerson_id,
	0 as deleted,
	tmpTempInvalidDoctype.`type` as `type`,
	tmpTempInvalidDoctype.doctype as doctype,
	rbTempInvalidDocument.id as doctype_id, 
	tmpTempInvalid.documentSerial as serial,
	tmpTempInvalid.documentNumber as `number`,
	tmpTempInvalid.Client_id as client_id,
	tmpReason.rbReason as tempInvalidReason_id,
	tmpTempInvalid.begDate as begDate,
	tmpTempInvalid.endDate as endDate,
	tmpMed.Person_id as person_id,
	tmpDiagnosis.Diagnosis_id as diagnosis_id,
	if(Period1.care, 3 - Period1.sex, 0) as sex, -- раз в стат. талонах пол нумеруется наоборот, значит, и здесь
	if(Period1.care, Period1.howOld, 0) as age,
	'Импортировано из SV' as notes, 
	datediff(tmpTempInvalid.endDate, tmpTempInvalid.begDate) + 1 as duration,
	1 as closed, -- всегда ставим "закрыт"
	NULL as prev_id, -- пока не отслеживаем цепочки больняков!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	0 as insuranceOfficeMark, -- новое поле!!!
	tmpTempInvalid.begDate as caseBegDate -- совсем новое поле!!!
from tmpTempInvalid
left join tmpNetrsop Period1 on Period1.tmpTempInvalid_id = tmpTempInvalid.id
			and Period1.begKey = Period1.`key`
left join tmpNetrsop Period2 on Period2.begKey = Period1.`key`
			and Period2.`key` != Period1.`key`
			and (Period2.openDate = Period1.closeDate + 1 or Period2.openDate = Period1.closeDate)
			and Period2.openPeriodKey = Period2.`key`		
left join tmpStattal on Period1.`key` = tmpStattal.`key`
left join tmpDiagnosis on tmpStattal.tmpDiagnosis_id = tmpDiagnosis.id
left join tmpMed on if(Period1.documentType = 3, Period2.openVrach, Period1.openVrach) = tmpMed.code -- берём врача, открывшего 1-й период для внутреннего больняка или 2-й период, если 1-й - внешний
left join tmpTempInvalidDoctype on Period1.documentType = tmpTempInvalidDoctype.svDoctype
left join rbTempInvalidDocument on tmpTempInvalidDoctype.`type` = rbTempInvalidDocument.`type`
				    and tmpTempInvalidDoctype.rbDoctype = rbTempInvalidDocument.code
left join tmpReason on 	tmpReason.svReason = Period1.why 
			and tmpReason.care = Period1.care
where TempInvalid_type = 5
and tmpTempInvalid.endDate is not null
and Period1.documentType in (1, 3, 4) -- больничные листы, больничные листы др. учреждения и продлённые больничные листы
and rbTempInvalidDocument.id is not null
and tmpReason.rbReason is not null;


select 'Установка соответствий для добавленных документов нетрудоспособности...' as ' ';

update tmpTempInvalid, TempInvalid
set tmpTempInvalid.TempInvalid_id = TempInvalid.id,
tmpTempInvalid.TempInvalid_type = 2
where tmpTempInvalid.Client_id = TempInvalid.client_id
and tmpTempInvalid.endDate is not null
and tmpTempInvalid.begDate <= TempInvalid.begDate
and tmpTempInvalid.endDate + 1 >= TempInvalid.begDate;



select 'Добавление периодов...' as ' ';
-- добавляем TempInvalid_Period
insert into TempInvalid_Period
select	0 as id,
	tmpTempInvalid.TempInvalid_id as master_id,
	tmpDiagnosis.Diagnosis_id as diagnosis_id,
	MedOpen.Person_id as begPerson_id,
	tmpNetrsop.openDate as begDate,
	MedClose.Person_id as endPerson_id,
	(select max(closeDate) from tmpNetrsop t2
		where t2.openPeriodKey = tmpNetrsop.`key`) as endDate, -- по пересечениям максимальную дату
	if(tmpNetrsop.documentType = 3, 1, 0) as isExternal,
	NULL as regime_id,
	NULL as break_id,
	(select id from rbTempInvalidResult
		where code = '2' -- сперва всем ставим, что они нетрудоспособны
		limit 1) as result_id, 
	tmpNetrsop.note as note
from tmpNetrsop
left join tmpTempInvalid on tmpNetrsop.tmpTempInvalid_id = tmpTempInvalid.id
left join tmpStattal on tmpNetrsop.`key` = tmpStattal.`key`
left join tmpDiagnosis on tmpStattal.tmpDiagnosis_id = tmpDiagnosis.id
left join tmpMed MedOpen on tmpNetrsop.openVrach = MedOpen.code
left join tmpMed MedClose on tmpNetrsop.closeVrach = MedClose.code
where tmpNetrsop.TempInvalid_Period_type = 5
and tmpTempInvalid.TempInvalid_type = 2;



select 'Установка соответствий для добавленных периодов...' as ' ';


update tmpNetrsop
left join tmpTempInvalid on tmpNetrsop.tmpTempInvalid_id = tmpTempInvalid.id, 
TempInvalid_Period
left join TempInvalid on TempInvalid_Period.master_id = TempInvalid.id
set tmpNetrsop.TempInvalid_Period_id = TempInvalid_Period.id,
tmpNetrsop.TempInvalid_Period_type = 2
where tmpTempInvalid.TempInvalid_id = TempInvalid.id
and tmpNetrsop.openDate = TempInvalid_Period.begDate;

-- Вот теперь устанавливаем трудоспособность: последний период всегда трудоспособен.
update TempInvalid_Period
left join TempInvalid on TempInvalid_Period.master_id = TempInvalid.id
set TempInvalid_Period.result_id = (select id from rbTempInvalidResult
		where code = '1' -- трудоспособен
		limit 1)
where TempInvalid.notes = 'Импортировано из SV'
and TempInvalid_Period.endDate = TempInvalid.endDate; -- последний период

select 'Импорт данных о документах нетрудоспособности завершён.' as ' ';


select 'Удаление диагнозов, которые ни с чем не связаны...' as ' ';
-- исправляем даты диагнозов:
update TempInvalid
left join Diagnosis on TempInvalid.diagnosis_id = Diagnosis.id
set Diagnosis.setDate = TempInvalid.begDate,
Diagnosis.endDate = TempInvalid.begDate
where Diagnosis.endDate = '0000-00-00';

update TempInvalid_Period
left join Diagnosis on TempInvalid_Period.diagnosis_id = Diagnosis.id
set Diagnosis.setDate = TempInvalid_Period.begDate,
Diagnosis.endDate = TempInvalid_Period.begDate
where Diagnosis.endDate = '0000-00-00';

-- а вот теперь удаляем 'пустые' диагнозы, для которых нет ни диагностики, ни периодов:
-- аналог deleteOrphanedDiagnosis, но для всех:
delete from Diagnosis
where not exists (select * from Diagnostic where Diagnostic.diagnosis_id = Diagnosis.id)
and not exists (select * from TempInvalid where TempInvalid.diagnosis_id = Diagnosis.id)
and not exists (select * from TempInvalid_Period where TempInvalid_Period.diagnosis_id = Diagnosis.id);
update tmpDiagnosis
set Diagnosis_type = 4
where not exists (select * from Diagnosis
			where tmpDiagnosis.Diagnosis_id = Diagnosis.id);