select 'Импорт статистических талонов (stattal)...' as ' ';

update tmpStattal
set Event_type = 0 -- неизвестно
where Event_type is null;
update tmpStattal
set Diagnostic_type = 0 -- неизвестно
where Diagnostic_type is null;






select 'Определение обращений и установка соответствий...' as ' ';

update tmpStattal
left join tmpMed on tmpStattal.vrach = tmpMed.code,
Event
set tmpStattal.Event_id = Event.id,
    tmpStattal.Event_type = 2
where tmpStattal.Client_id = Event.client_id
and tmpStattal.endDate = Event.execDate
and tmpMed.Person_id = Event.execPerson_id; -- идентифицируем обращение по дате окончания, клиенту и врачу

select 'Некорректные даты начала и окончания:' as ' ';
select concat('Ключ ', convert(`key` using utf8)), begDate, endDate
from tmpStattal
where not (
year(tmpStattal.begDate) >= 1900
and tmpStattal.begDate <= tmpStattal.endDate
and tmpStattal.endDate <= date(now())
);

update tmpStattal
set eventResult = 0
where eventResult is NULL; 
select concat('В ', convert(count(*) using utf8), ' стат. талонах не указана цель обращения, диагноз или результат.')
from tmpStattal
where purpose is NULL or purpose = 0
or MKB is NULL or MKB = ''
or eventResult = 0;
--select 'Не указана цель обращения, диагноз или результат:' as ' ';
--select concat('Ключ ', convert(`key` using utf8)), purpose, MKB, eventResult
--from tmpStattal
--where purpose is NULL or purpose = 0
--or MKB is NULL or MKB = ''
--or eventResult = 0;

select concat('Найдено ', convert(count(*) using utf8), ' непонятных характеров заболевания.') --concat('Ключ ', `key`), diseaseCharacter, MKB
from tmpStattal
left join tmpDiseaseCharacter on tmpStattal.diseaseCharacter = tmpDiseaseCharacter.svDiseaseCharacter
where tmpDiseaseCharacter.rbDiseaseCharacter is null and left(MKB, 1) != 'Z';

--Определять талон по дате закрытия (талона), пациенту и врачу. Не дублировать!
select concat('Для ', convert(count(*) using utf8), ' стат. талонов дублируется пациент, конечная дата и врач.')
from tmpStattal A
where A.Event_type = 2
and A.begDate = (select min(B.begDate) from tmpStattal B -- сортируем лексикографически по начальной дате и ключу
		where B.Event_type = 2
		and A.Client_id = B.Client_id
		and A.endDate = B.endDate
		and A.vrach = B.vrach
		and A.`key` != B.`key` 
		)
and A.`key` = (select min(B.`key`) from tmpStattal B -- сортируем лексикографически по начальной дате и ключу
		where B.Event_type = 2
		and A.Client_id = B.Client_id
		and A.begDate = B.begDate
		and A.endDate = B.endDate
		and A.vrach = B.vrach);




select 'Определение посещений (gosop) и сопоставление со стат. талонами...' as ' ';

--Если нет визитов - не грузить и писать в протокол.
select 'Для следующих стат. талонов не найдено ни одного посещения:' as ' ';
select concat('Ключ ', convert(tmpStattal.`key` using utf8)) from tmpStattal
WHERE NOT EXISTS (SELECT * 
			FROM tmpGosop
			WHERE tmpGosop.`key` = tmpStattal.`key` 
		);
select 'Такие стат. талоны не будут загружены.' as ' ';
update tmpStattal
set Event_type = 4
where NOT EXISTS (SELECT * 
			FROM tmpGosop
			WHERE tmpGosop.`key` = tmpStattal.`key` 
		);

-- теперь ставим начальную и конечную дату Event'ов по визитам:
update tmpStattal
set firstVisitDate = (select `date` from tmpGosop
where tmpGosop.`key` = tmpStattal.`key`
order by `date` limit 1);

update tmpStattal
set endDate = (select max(`date`) from tmpGosop
where tmpGosop.`key` = tmpStattal.`key`);










select 'Добавление обращений...' as ' ';

-- Обрабатываем (добавляем или редактируем) только обращения существующих клиентов
update tmpStattal
set Event_type = 5
where Event_type = 0
and Client_id is not null;


insert into Event
select 0 as id,
    now() as createDatetime,
    @person_id as createPerson_id,
    now() as modifyDatetime,
    @person_id as modifyPerson_id,
    0 as deleted,
    `key` as externalId,
    EventType.id as eventType_id,
    @org_id as org_id,
    Client_id as client_id,
    NULL as contract_id, -- ?????????????????
    NULL as prevEventDate,
    if(begDate < firstVisitDate, begDate, firstVisitDate) as setDate,  --begDate as setDate?????????????,
    tmpMed.Person_id as setPerson_id,
    endDate as execDate,
    tmpMed.Person_id as execPerson_id, -- а если нет врача, импортировать?????????????????????????????????
    isPrimary,
    1 as `order`,
    rbResult.id as result_id,
    NULL as nextEventDate,
    0 as payStatus,
    NULL as typeAsset_id, -- новое поле!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    'Импортировано из SV' as note,
    NULL as curator_id, -- новое поле!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    NULL as assistant_id, -- новое поле!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    0 as pregnancyWeek, -- new field!!!!!!!!!!!!!!!!!!!!!!
    NULL as MES_id  -- new field!!!!!!!!!!!!!!!!!!!!!!
from tmpStattal
left join tmpMed on tmpStattal.vrach = tmpMed.code
left join tmpPurpose on tmpStattal.purpose = tmpPurpose.svPurpose
left join EventType on tmpPurpose.eventTypeCode = EventType.code
left join tmpResults on tmpStattal.purpose = tmpResults.svPurpose and tmpStattal.eventResult = tmpResults.svResult
left join rbResult on eventPurpose_id = EventType.purpose_id and rbResult.code = tmpResults.rbResultCode
where tmpStattal.Event_type = 5
and tmpPurpose.eventTypeCode is not null
and tmpResults.rbResult is not null 
and MKB != ''
and (tmpStattal.diseaseCharacter in (1, 2, 3, 4, 5) or left(MKB, 1) = 'Z') -- добавляем, только если точно определена цель, результат, диагноз и характер заболевания
-- 5 считаем за 4!!!!!!!!!!!!!!!!!!
and year(if(tmpStattal.begDate < tmpStattal.firstVisitDate, tmpStattal.begDate, tmpStattal.firstVisitDate)) >= 1900
and if(tmpStattal.begDate < tmpStattal.firstVisitDate, tmpStattal.begDate, tmpStattal.firstVisitDate) <= tmpStattal.endDate
and tmpStattal.endDate <= date(now()); -- простой контроль дат

select 'Установка соответствий для добавленных обращений...' as ' ';
-- Обращение идентифицируется по клиенту, дате и врачу
update tmpStattal
left join tmpMed on tmpStattal.vrach = tmpMed.code,
Event
set tmpStattal.Event_id = Event.id,
    tmpStattal.Event_type = 2
where tmpStattal.Client_id = Event.client_id
and tmpStattal.endDate = date(Event.execDate)
and (tmpMed.Person_id = Event.execPerson_id
	 or (tmpMed.Person_id is null and Event.execPerson_id is null)); 

-- Патч!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-- добавляет врачей в том случае, если их нет в таблице tmpMed
update Event
left join tmpStattal on tmpStattal.Event_id = Event.id and tmpStattal.Event_type = 2
left join Person on tmpStattal.vrach = Person.code
set Event.setPerson_id = Person.id,
Event.execPerson_id = Person.id
where Event.execPerson_id is null
and Event.note = 'Импортировано из SV';


select 'Импорт данных об обращениях завершён.' as ' ';