# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################
from PyQt4.QtCore import Qt

from library.interchange     import ( setLineEditValue,
                                      setDateEditValue,
                                      getLineEditValue,
                                      getDateEditValue,
                                    )
from library.ItemsListDialog import CItemEditorBaseDialog
from library.Utils           import forceStringEx

from Accounting.Ui_AccountEditDialog import Ui_AccountEditDialog


class CAccountEditDialog(CItemEditorBaseDialog, Ui_AccountEditDialog):
    def __init__(self,  parent):
        CItemEditorBaseDialog.__init__(self, parent, 'Account')
        self.setupUi(self)
        self.setWindowFlags(self.windowFlags() | Qt.WindowMaximizeButtonHint)
        self.setWindowTitleEx(u'Счет')
        self.setupDirtyCather()


    def setRecord(self, record):
        CItemEditorBaseDialog.setRecord(self, record)
        setLineEditValue(self.edtNumber,      record, 'number')
        setDateEditValue(self.edtDate,        record, 'date')
        setDateEditValue(self.edtExposeDate,  record, 'exposeDate')
        setLineEditValue(self.edtNote,        record, 'note')
        setDateEditValue(self.edtPrivateDate, record, 'personalDate')
        self.setIsDirty(False)


    def getRecord(self):
        record = CItemEditorBaseDialog.getRecord(self)
        getLineEditValue(self.edtNumber,      record, 'number')
        getDateEditValue(self.edtDate,        record, 'date')
        getDateEditValue(self.edtExposeDate,  record, 'exposeDate')
        getLineEditValue(self.edtNote,        record, 'note')
        getDateEditValue(self.edtPrivateDate, record, 'personalDate')
        return record


    def checkDataEntered(self):
        result = True
        number = forceStringEx(self.edtNumber.text())
        result = result and (number or self.checkInputMessage(u'Номер', False, self.edtNumber))
        return result
