# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

# Свойство типа "число с плавающей точкой"

from PyQt4 import QtGui
from PyQt4.QtCore import QVariant

from library.StrComboBox   import CDoubleComboBox
from library.Utils         import forceDouble

from ActionPropertyValueType       import CActionPropertyValueType


class CDoubleActionPropertyValueType(CActionPropertyValueType):
    name         = 'Double'
    variantType  = QVariant.Double

    class CPropEditor(QtGui.QLineEdit):
        def __init__(self, action, domain, parent, clientId, eventTypeId):
            QtGui.QLineEdit.__init__(self, parent)
            self._validator = QtGui.QDoubleValidator(self)
            self.setValidator(self._validator)

        def setValue(self, value):
            v = forceDouble(value)
            self.setText(str(v))

        def value(self):
            return self.text().toDouble()[0]


    class CComboBoxPropEditor(CDoubleComboBox):
        def __init__(self, action, domain, parent, clientId, eventTypeId):
            CDoubleComboBox.__init__(self, parent)
            self.setDomain(domain)

        def setValue(self, value):
            v = forceDouble(value)
            CDoubleComboBox.setValue(self, str(v))

        def value(self):
            return forceDouble(CDoubleComboBox.value(self))

    @staticmethod
    def convertDBValueToPyValue(value):
        res = value.toDouble()
        if not res[1]:
            str = value.toString()
            str.replace(',', '.')
            res = QVariant(str).toDouble()
        return res[0]


    convertQVariantToPyValue = convertDBValueToPyValue


    def toInfo(self, context, v):
        return v if v else 0.0


    def getEditorClass(self):
        if self.domain:
            return self.CComboBoxPropEditor
        else:
            return self.CPropEditor
#

