# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4 import QtGui
from PyQt4.QtCore import QVariant


from library.crbcombobox import CRBComboBox
from library.Utils       import forceRef, forceString
from ActionPropertyValueType       import CActionPropertyValueType


class CSpecialityActionPropertyValueType(CActionPropertyValueType):
    name         = 'rbSpeciality'
    variantType  = QVariant.Int

    class CPropEditor(CRBComboBox):
        def __init__(self, action, domain, parent, clientId, eventTypeId):
            CRBComboBox.__init__(self, parent)
#            self.domain = domain
            self.setTable('rbSpeciality', addNone=True)

        def setValue(self, value):
            CRBComboBox.setValue(self, forceRef(value))


    @staticmethod
    def convertDBValueToPyValue(value):
        return forceRef(value)


    convertQVariantToPyValue = convertDBValueToPyValue


    def toInfo(self, context, v):
        from Orgs.PersonInfo import CSpecialityInfo
        return CSpecialityInfo(context, v)


    def toText(self, v):
        return forceString(QtGui.qApp.db.translate('rbSpeciality', 'id', v, 'name'))


