# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

#
from PyQt4 import QtGui
from PyQt4.QtCore import Qt, QVariant

from library.StrComboBox           import CStrComboBox
from library.Utils                 import forceString
from ActionPropertyValueType       import CActionPropertyValueType

class CStringActionPropertyValueType(CActionPropertyValueType):
    name         = 'String'
    variantType  = QVariant.String

    class CPlainPropEditor(QtGui.QLineEdit):
        def __init__(self, action, domain, parent, clientId, eventTypeId):
            QtGui.QLineEdit.__init__(self, parent)

        def setValue(self, value):
            v = forceString(value)
            self.setText(v)

        def value(self):
            return unicode(self.text())


    class CComboBoxPropEditor(CStrComboBox):
        def __init__(self, action, domain, parent, clientId, eventTypeId):
            CStrComboBox.__init__(self, parent)
            self.setDomain(domain)


    @staticmethod
    def convertDBValueToPyValue(value):
        return forceString(value)


    convertQVariantToPyValue = convertDBValueToPyValue


    def getEditorClass(self):
        if self.domain:
            return self.CComboBoxPropEditor
        else:
            return self.CPlainPropEditor


#    @staticmethod
#    def getDomainEditorClass():
#        return CStringDomainEditor
#
#
#class CStringDomainEditor(CDialogBase):


