# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4 import QtGui
from PyQt4.QtCore import QVariant

from library.PrintInfo       import CTimeInfo
from library.Utils           import forceString
from ActionPropertyValueType import CActionPropertyValueType


class CTimeActionPropertyValueType(CActionPropertyValueType):
    name         = 'Time'
    variantType  = QVariant.Time

    class CPropEditor(QtGui.QTimeEdit):
        def __init__(self, action, domain, parent, clientId, eventTypeId):
            QtGui.QLineEdit.__init__(self, parent)

        def setValue(self, value):
            v = value.toTime()
            self.setTime(v)

        def value(self):
            return self.time()


    @staticmethod
    def convertDBValueToPyValue(value):
        return value.toTime()


    convertQVariantToPyValue = convertDBValueToPyValue


    def toText(self, v):
        return forceString(v)


    def toInfo(self, context, v):
        return CTimeInfo(v)

