# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

u"""
Описание свойств Action
"""
__all__ = (# 'CActionPropertyType',
           # 'CActionPropertyValueType',
           # 'CActionPropertyValueTypeRegistry',
            'CActionProperty',
          )

from ActionPropertyValueType  import CActionPropertyValueTypeRegistry

from ArterialPressureActionPropertyValueType    import CArterialPressureActionPropertyValueType
from BlankNumberActionPropertyValueType         import CBlankNumberActionPropertyValueType
from BlankSerialActionPropertyValueType         import CBlankSerialActionPropertyValueType
from BlankSerialNumberActionPropertyValueType   import CBlankSerialNumberActionPropertyValueType
from ClientQuotingActionPropertyValueType       import CClientQuotingActionPropertyValueType
from ComplaintsActionPropertyValueType          import CComplaintsActionPropertyValueType
from ConstructorActionPropertyValueType         import CConstructorActionPropertyValueType
from ContractActionPropertyValueType            import CContractActionPropertyValueType
from CounterActionPropertyValueType             import CCounterActionPropertyValueType
from CsgActionPropertyValueType                 import CCsgActionPropertyValueType
from DateActionPropertyValueType                import CDateActionPropertyValueType
from DoubleActionPropertyValueType              import CDoubleActionPropertyValueType
from FeatureActionPropertyValueType             import CFeatureActionPropertyValueType
from FinanceActionPropertyValueType             import CFinanceActionPropertyValueType
from HospitalBedActionPropertyValueType         import CHospitalBedActionPropertyValueType
from HospitalBedProfileActionPropertyValueType  import CHospitalBedProfileActionPropertyValueType
from HtmlActionPropertyValueType                import CHtmlActionPropertyValueType
from ImageActionPropertyValueType               import CImageActionPropertyValueType
from ImageMapActionPropertyValueType            import CImageMapActionPropertyValueType
from IntegerActionPropertyValueType             import CIntegerActionPropertyValueType
from JobTicketActionPropertyValueType           import CJobTicketActionPropertyValueType
from NomenclatureActionPropertyValueType        import CNomenclatureActionPropertyValueType
from OrganisationActionPropertyValueType        import COrganisationActionPropertyValueType
from OrgStructureActionPropertyValueType        import COrgStructureActionPropertyValueType
from OrgStructurePlacementActionPropertyValueType import COrgStructurePlacementActionPropertyValueType
from PacsActionPropertyValueType                import CPacsActionPropertyValueType
from PersonActionPropertyValueType              import CPersonActionPropertyValueType
from PhaseMenstrualActionPropertyValueType      import CPhaseMenstrualActionPropertyValueType
from PulseActionPropertyValueType               import CPulseActionPropertyValueType
from RadiationDoseActionPropertyValueType       import CRadiationDoseActionPropertyValueType
from ReferenceActionPropertyValueType           import CReferenceActionPropertyValueType
from RLSActionPropertyValueType                 import CRLSActionPropertyValueType
from SamplingActionPropertyValueType            import CSamplingActionPropertyValueType
from SocStatusActionPropertyValueType           import CSocStatusActionPropertyValueType
from SpecialityActionPropertyValueType          import CSpecialityActionPropertyValueType
from StringActionPropertyValueType              import CStringActionPropertyValueType
from TemperatureActionPropertyValueType         import CTemperatureActionPropertyValueType
from TextActionPropertyValueType                import CTextActionPropertyValueType
from TimeActionPropertyValueType                import CTimeActionPropertyValueType
from ToothActionPropertyValueType               import CToothActionPropertyValueType
from UrlActionPropertyValueType                 import CUrlActionPropertyValueType

from ActionPropertyType       import CActionPropertyType
from ActionProperty           import CActionProperty

CActionPropertyValueTypeRegistry.register(CArterialPressureActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CBlankNumberActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CBlankSerialActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CBlankSerialNumberActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CClientQuotingActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CComplaintsActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CConstructorActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CContractActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CCounterActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CCsgActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CDateActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CDoubleActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CFeatureActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CFinanceActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CHospitalBedActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CHospitalBedProfileActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CHtmlActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CImageActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CImageMapActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CIntegerActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CJobTicketActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CNomenclatureActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(COrganisationActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(COrgStructureActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(COrgStructurePlacementActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CPacsActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CPersonActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CPhaseMenstrualActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CPulseActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CRadiationDoseActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CReferenceActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CRLSActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CSamplingActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CSocStatusActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CSpecialityActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CStringActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CTemperatureActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CTextActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CTimeActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CToothActionPropertyValueType)
CActionPropertyValueTypeRegistry.register(CUrlActionPropertyValueType)
