# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2015-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4.QtCore          import Qt

from library.DialogBase    import CDialogBase

from Registry.Utils        import getClientBanner

from Events.Ui_AmbCardDialog   import Ui_AmbCardDialog


class CAmbCardDialog(CDialogBase, Ui_AmbCardDialog):
    def __init__(self, parent=None, clientId=None):
        CDialogBase.__init__(self, parent)

        self.setupUi(self)

        self.setWindowFlags(self.windowFlags() | Qt.WindowMaximizeButtonHint)
        self.setClientId(clientId)
        self.ambCardPageWidget.resetWidgets()


    def setClientId(self, clientId):
        self._clientId = clientId
        if clientId:
            self.txtClientInfoBrowser.setHtml(getClientBanner(clientId))
        else:
            self.txtClientInfoBrowser.setText('')
        self.ambCardPageWidget.setClientId(clientId)


