# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from library.PrintInfo import CInfo
from library.ICDUtils  import getMKBClassName, getMKBBlockName, getMKBName


class CMKBInfo(CInfo):
    def __init__(self, context, code):
        CInfo.__init__(self, context)
        self.code = code
        self._descr = None
        self._class = None
        self._block = None
        self._ok = bool(self.code)
        self._loaded = True


    def getClass(self):
        if self._class is None:
            self._class = getMKBClassName(self.code) if self.code else ''
        return self._class


    def getBlock(self):
        if self._block is None:
            self._block = getMKBBlockName(self.code) if self.code else ''
        return self._block


    def getDescr(self):
        if self._descr is None:
            self._descr = getMKBName(self.code) if self.code else ''
        return self._descr


    class_ = property(getClass)
    block = property(getBlock)
    descr = property(getDescr)

    def __str__(self):
        return self.code


class CMorphologyMKBInfo(CInfo):
    def __init__(self, context, code):
        CInfo.__init__(self, context)
        self.code = code
        self._ok = bool(self.code)
        self._loaded = True

    def __str__(self):
        return self.code
