# -*- coding: utf-8 -*-

#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4 import QtGui

class CMapActionTypeIdToServiceIdList:
    def __init__(self):
        self.mapActionTypeIdToServiceIdList = {}


    def getActionTypeServiceIdList(self, actionTypeId, financeId):
        key = (actionTypeId, financeId)
        result = self.mapActionTypeIdToServiceIdList.get(key, False)
        if result == False:
            db = QtGui.qApp.db
            table = db.table('ActionType_Service')
            result = db.getDistinctIdList(table,
                                          idCol='service_id',
                                          where=[table['master_id'].eq(actionTypeId),
                                                 table['finance_id'].eq(financeId),
                                                 table['service_id'].isNotNull()])
            if not result:
                result = db.getDistinctIdList(table,
                                          idCol='service_id',
                                          where=[table['master_id'].eq(actionTypeId),
                                                 table['finance_id'].isNull(),
                                                 table['service_id'].isNotNull()])
            self.mapActionTypeIdToServiceIdList[key] = result
        return result


    def reset(self):
        self.mapActionTypeIdToServiceIdList = {}
