# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

import json, sip

from PyQt4 import QtGui, QtSql
from PyQt4.QtCore import Qt, SIGNAL, QString, QVariant, QSize, QDate, QDateTime

from library.Utils                         import copyFields, forceBool, forceRef, forceStringEx, toVariant, forceString, forceDateTime, forceDate
from library.InDocTable                    import CInDocTableView, CRecordListModel, CLocItemDelegate
from Registry.ClientRelationSimpleComboBox import CClientRelationSimpleComboBox
from Registry.Utils                        import getRightEditTempInvalid, deleteTempInvalidDocument
from Events.Action                         import CAction, CActionTypeCache
from Events.Utils                          import getActionTypeIdListByFlatCode, checkTissueJournalStatusByActions
from Events.ActionTypeDialog               import CActionTypeDialogTableModel
from Events.ActionCreateDialog             import CActionCreateDialog
from Users.Rights                          import urRegTabEditExpertMC


class CDatePeriodsItemDelegate(CLocItemDelegate):
    def __init__(self, parent):
        CLocItemDelegate.__init__(self, parent)


    def setEditorData(self, editor, index):
        if editor is not None:
            column = index.column()
            row    = index.row()
            model  = index.model()
            if row < len(model.items()):
                record = model.items()[row]
            else:
                record = model.table.newRecord()
                if len(model.items()) >= 1:
                    item = model.items()[row-1]
                    begDate = forceDate(item.value('begDate'))
                    endDate = forceDate(item.value('endDate'))
                    if begDate < endDate:
                        model.setEditorData(column, editor, toVariant(endDate.addDays(1)), record)
                        return
            model.setEditorData(column, editor, model.data(index, Qt.EditRole), record)


class CTempInvalidPeriodsInDocTableView(CInDocTableView):

    Col_BegDate       = 0
    Col_EndDate       = 1
    Col_ChairPersonId = 4

    def __init__(self, parent):
        CInDocTableView.__init__(self, parent)
        self.datePeriodsItemDelegate = CDatePeriodsItemDelegate(self)
        self.setItemDelegateForColumn(CTempInvalidPeriodsInDocTableView.Col_BegDate, self.datePeriodsItemDelegate)
        self.setItemDelegateForColumn(CTempInvalidPeriodsInDocTableView.Col_EndDate, self.datePeriodsItemDelegate)
        self.resizeRowsToContents()


