# -*- coding: utf-8 -*-
'''
Created on 04.09.2012

@author: Alex Parfentjev
'''
from PyQt4 import QtGui
from PyQt4.QtCore import Qt

from library.Utils     import forceDate, forceInt, forceRef, forceString


class Export29XMLCommon(object):
    u'''
    здесь будут храниться методы общего назначения для подушевого и простого экспортов
    это необходимо чтобы гарантировать одновременность правок (избегать двойного кода),
    а также собрать воедино в статические методы те вещи, которые имеют общее назначение
    '''

#unused yet
    def __init__(self):
        pass


    @staticmethod
    def isPatientAttached(db, clientId):
        stmt = """SELECT `rbAttachType`.`code` as CODE
                  FROM
                  `ClientAttach`
                  LEFT JOIN `rbAttachType` ON `rbAttachType`.`id` = `ClientAttach`.`AttachType_id`
                  WHERE `client_id` =%d"""%clientId
        query = db.query(stmt)
        if query.next():
            return forceInt(query.record().value('CODE')) == 1


    @staticmethod
    def getDatesForAction(db, eventId, actionId = None, serviceStr = None):
        if serviceStr and (serviceStr[:4] == '5.20' or serviceStr[:4] == '5.19'):
            stmt = """SELECT `begDate` AS `begDate`, `endDate` AS `endDate`
                    FROM `Action`
                    WHERE `Action`.`id` = %d """%(actionId)
        elif serviceStr and ((serviceStr[:4] == '3.8.') or (serviceStr[:5] == '3.15.')):
            stmt = """SELECT `begDate` AS `begDate`, `endDate` AS `endDate`
                    FROM `Action`
                    WHERE `Action`.`id` = %d """%(actionId)

        else:
            stmt = """SELECT MIN(`begDate`) AS `begDate`, MAX(`endDate`) AS `endDate`
                  FROM
                  `Action`
                  LEFT JOIN `ActionType` ON `ActionType`.`id` = `Action`.`ActionType_id`
                  WHERE `Action`.`Event_Id` = %d """%(eventId)

        query = db.query(stmt)

        if query.next():
            #возвращаем первый actionId, т.е. самый новый
            begDate = forceDate(query.record().value('begDate'))
            endDate = forceDate(query.record().value('endDate'))

        try:
            begDate
        except:
            begDate = None

        try:
            endDate
        except:
            endDate = None

        return (begDate, endDate)


    @staticmethod
    def getDatesForEvent(db, eventId):
        stmt = """SELECT  `setDate`  as begDate,  `execDate` as endDate
                  FROM  `Event`
                  WHERE  `id` = %d """%eventId
        query = db.query(stmt)
        if query.next():
            return (forceDate(query.record().value('begDate')),
                    forceDate(query.record().value('endDate')))
        else:
            return None, None


    @staticmethod
    def getPcode(db, record, visitId = None):
        actionId = forceInt(record.value('action_id'))
        if not visitId: visitId= forceInt(record.value('visit_id'))
        eventId = forceInt(record.value('event_id'))
        stmt = """SELECT `Person`.`SNILS` as `code`, `Person`.`id` as `personId`
                        FROM `Person`
                        LEFT JOIN `TableName` ON `TableName`.`person_id` = `Person`.`id`
                        WHERE
                        `TableName`.`id` = %d"""

        if (not actionId and not visitId):
            if eventId:
                stmt = stmt.replace('TableName', 'Event').replace('person_id', 'execPerson_id') %eventId
            else:
                return None, None
        else:
            if actionId:
                stmt = stmt.replace('TableName', 'Action')%actionId
            elif visitId:
                stmt = stmt.replace('TableName', 'Visit')%visitId
        query = db.query(stmt)
        if query.next():
            return forceString(query.record().value('personId')), forceString(query.record().value('code'))
        else:
            return None, None


    @staticmethod
    def getHelpForm(db, eventId, order):
        helpForm = 0
        type = 0
        if order == '1':
            helpForm = 3
        elif order in ('2'):
            helpForm = 1
        else:
             helpForm = 3
        stmt = """SELECT rbMedicalAidKind.code as code FROM `Event`
                LEFT JOIN `EventType` On `EventType`.id = `Event`.`eventType_id`
                LEFT JOIN rbMedicalAidKind ON rbMedicalAidKind.id = EventType.medicalAidKind_id
                WHERE `Event`.id =%d"""%( eventId)
        query = db.query(stmt)
        if query.next():
            if forceString(query.record().value('code')) == '12' or order == '6':
                helpForm = 2
        return helpForm


    @staticmethod
    def getLatestActionMove(db, masterId, eventId):
        u'Возвращает самое последнее движение'
        stmt = """SELECT `Account_Item`.`service_id` AS serviceId,
                         `Account_Item`.`id` AS Id,  rbService.code AS code
                FROM
                    `Account_Item`
                    LEFT JOIN `Action` ON `Account_Item`.`action_id` = `Action`.`id`
                    LEFT JOIN `ActionType` ON `ActionType`.`id` = `Action`.`actionType_id`
                    LEFT JOIN rbService ON Account_Item.`service_id` = rbService.id
                    WHERE Master_id = %d AND `Account_Item`.`event_id` = %d
                    AND `ActionType`.`flatCode` = 'moving'
                ORDER BY `Action`.`begDate` DESC
                LIMIT 1
                """%(masterId, eventId)
        query = db.query(stmt)
        if query.next():
                if forceString(query.record().value('code')) == '5.20' or forceString(query.record().value('code')) == '5.19':
                    return None, None
                else:
                    return (forceInt(query.record().value('serviceId')),
                            forceInt(query.record().value('Id')))
        else:
            return None, None


    @staticmethod
    def getSpecialCaseCode(db, clientId, contractBegDate = None):
        stmStr = "and ClientSocStatus.endDate > '%s'"% contractBegDate.toString(Qt.ISODate) if contractBegDate else ''
        stmt = """SELECT rbSocStatusType.code as code, ClientSocStatus.endDate
                    FROM `ClientSocStatus`
                    LEFT JOIN rbSocStatusType ON rbSocStatusType.id = `ClientSocStatus`.`socStatusType_id`
                    LEFT JOIN rbSocStatusClass ON rbSocStatusClass.id = `ClientSocStatus`.`socStatusClass_id`
                     WHERE `client_id` = %d and rbSocStatusClass.code = 10
                     and ClientSocStatus.deleted =0 %s
                     """%(clientId, stmStr)
        query = db.query(stmt)
        if query.next():
            return forceString(query.record().value('code'))
        else:
            return None


    @staticmethod
    def getLatestDateOfVisitOrAction(db, masterId, eventId):
        u'Возвращает дату последнего джвижения'
        stmtAction = """SELECT `Action`.`endDate` as EndDate
                    FROM  `Account_Item`
                    LEFT JOIN `Action` ON `Account_Item`.`action_id` = `Action`.`id`
                    LEFT JOIN `ActionType` ON `ActionType`.`id` = `Action`.`actionType_id`
                    WHERE Master_id = %d AND `Account_Item`.`event_id` = %d
                    AND `ActionType`.`flatCode` = 'moving'
               ORDER BY `begDate` DESC
                """%(masterId, eventId)

        u'Возвращает дату последнего визита'
        stmtVisit = """ SELECT  `Visit`.`date` AS EndDate
                    FROM  `Account_Item`
                    LEFT JOIN  `Visit` ON  `Account_Item`.`visit_id` =  `Visit`.`id`
                    WHERE Master_id = %d AND `Account_Item`.`event_id` = %d
                    ORDER BY  `Visit`.`date` DESC
                    """%(masterId, eventId)
        query = db.query(stmtAction)
        if query.next():
            return (forceDate(query.record().value('EndDate')))
        else:
            queryH = db.query(stmtVisit)
            if queryH.next():
                return (forceDate(queryH.record().value('EndDate')))
            else:
                return None


    @staticmethod
    def getVisit(db, masterId, eventId, serviceId):
        stmt = """SELECT  `Visit`.`id` AS visitId
                    FROM  `Account_Item`
                    LEFT JOIN  `Visit` ON  `Account_Item`.`visit_id` =  `Visit`.`id`
                    WHERE Master_id = %d AND `Account_Item`.`event_id` = %d AND Visit.service_id=%d
                    ORDER BY  `Visit`.`visitType_id` DESC
                    """%(masterId, eventId, serviceId)
        query = db.query(stmt)
        if query.next():
            return (forceRef(query.record().value('visitId')))
        else:
            return None

#    @staticmethod
#    def getVisit(db, eventId, serviceId):
#        stmt = """SELECT  `Visit`.`id` AS visitId
#                    FROM  `Visit`
#                    WHERE `event_id` = %d AND Visit.service_id!=%d
#                    ORDER BY  `Visit`.`visitType_id` DESC
#                    """%( eventId, serviceId)
#        query = db.query(stmt)
#        visits = []
#        while query.next():
#            visits.append(forceRef(query.record().value('visitId')))
#        return (visits)

    @staticmethod
    def getDatesForConsultVisit(db, visitId):
        stmt = """SELECT  `date` as dateVisit
                    FROM  `Visit`
                    WHERE  `id` =%d"""%(visitId)
        query = db.query(stmt)
        if query.next():
            return (forceDate(query.record().value('dateVisit')))
        else:
            return None


    @staticmethod
    def getPersonRegionalCodeForConsultVisit(db, visitId):
        stmt = """SELECT  `Person`.`SNILS`  as regionalCode
                    FROM  `Person`
                    LEFT JOIN  `Visit` ON  `Person`.`id` =  `Visit`.`person_id`
                    WHERE  `Visit`.`id` =%d"""%(visitId)
        query = db.query(stmt)
        if query.next():
            return (forceString(query.record().value('regionalCode')))
        else:
            return None


    @staticmethod
    def doubleToStrRounded(f):
        slen = len('%.*f' % (2, f))
        return float(str(f + 0.006)[:slen])


    @staticmethod
    def doubleToStrCut(f):
        slen = len('%.*f' % (2, f))
        return float(str(f)[:slen])


    #WFT? есть же db.translate('Organisation', 'infisCode', miacCode, 'notes')
    @staticmethod
    def getMobileModule(db, miacCode):
        stmt = """SELECT  `notes` as MobileModule
                  FROM  `Organisation`
                  WHERE  `infisCode` =  %d
                  """%(miacCode)
        query = db.query(stmt)
        if query.next():
            return (forceString(query.record().value('MobileModule')))
        else:
            return None


    @staticmethod
    def getConnection(db, clientId):
        stmt = """SELECT lastName, firstName, patrName, birthDate, sex
                    FROM Client
                    WHERE Client.id = (
                    SELECT  `ClientRelation`.`client_id`
                    FROM  `ClientRelation`
                    WHERE  `relative_id` =%d and ClientRelation.deleted = 0
                    LIMIT 1 )
                  """%(clientId)
        query = db.query(stmt)
        if query.next():
            return ((forceString(query.record().value('lastName'))) ,
                    (forceString(query.record().value('firstName'))),
                    (forceString(query.record().value('patrName'))),
                    (forceDate(query.record().value('birthDate'))),
                    (forceString(query.record().value('sex'))))
        else:
            return None, None, None, None, None


    @staticmethod
    def diagnosisHasSpecification(db, mkb):
        stmt = """ SELECT LEFT(`DiagID`, 3) FROM `MKB`
        WHERE LENGTH(`DiagID`) >3 AND LEFT(`DiagID`, 3) = '%s' """%(mkb)
        query = db.query(stmt)
        if query.next():
            return True
        else:
            return False


    @staticmethod
    def changeOkato(okato):
        i=3
        g=len(okato)
        okatoH =okato
        while okatoH[-3:] == '000' and i<7:
            okatoH =okato[0:g-i]
            i=i+3
        else:
            return okatoH


    @staticmethod
    def isOverHospitalLimit(db, eventId):
        stmt = """SELECT `Contract_Tariff`.`frag2Start` as `limit`, `Contract_Tariff`.`amount` as `contractTariffAmount`, `Account_Item`.`amount` as accountAmount
                FROM  `Account_Item`
                LEFT JOIN `Contract_Tariff` ON `Contract_Tariff`.`id` =  `Account_Item`.`tariff_id`
                LEFT JOIN `Action` ON `Action`.`id` =  `Account_Item`.`action_id`
                LEFT JOIN  `ActionType` ON  `Action`.`actionType_id` =  `ActionType`.`id`
                WHERE  `Account_Item`.`event_id` =%d
                AND Contract_Tariff.amount <  `Account_Item`.`amount`
                AND (`Account_Item`.`amount` - Contract_Tariff.frag2Start) !=  `Account_Item`.`amount`
                """%(eventId)
        query = db.query(stmt)
        difference = 0
        amount = 0
        limit = 0
        contractTariffAmount = 0
        accountAmount = 0
        if query.next():
            limit = (forceInt(query.record().value('limit')))
            accountAmount = (forceInt(query.record().value('accountAmount')))
            contractTariffAmount= (forceInt(query.record().value('contractTariffAmount')))
        stmt1 = """    SELECT SUM(`Action`.AmoUnt) as sumAmount
                        FROM  `Action`
                        LEFT JOIN  `ActionType` ON  `Action`.`actionType_id` =  `ActionType`.`id`
                        WHERE `Action`.event_id =%d AND `ActionType`.`flatCode` =  'moving'"""%(eventId)
        query = db.query(stmt1)
        if query.next():
            amount = (forceInt(query.record().value('sumAmount')))
        if limit < amount and difference != amount:
            difference =  (amount - limit)
        return difference


    @staticmethod
    def getExtr(self, eventId):
        stmt = """SELECT IF(`ActionProperty_String`.`value` LIKE %s,1,2) as isExtr
                        FROM `ActionProperty_String`
                        WHERE `id` IN (SELECT `ActionProperty`.`id`
                                        FROM  `ActionProperty`
                                        LEFT JOIN `ActionPropertyType` ON `ActionPropertyType`.`id` = `ActionProperty`.`type_id`
                                        -- LEFT JOIN ActionType ON ActionType.id = `ActionPropertyType`.actionType_id
                                        LEFT JOIN `Action` ON `ActionProperty`.`action_id` = `Action`.id
                                        WHERE   `ActionPropertyType`.actionType_id =4076
                                        AND  `Action`.event_id =%d
                                        AND `ActionPropertyType`.`name` LIKE %s)"""%(u"""'плановым показаниям'""", eventId, u"""'Доставлен по'""")
        query =  QtGui.qApp.db.query(stmt)
        if query.next():
            return (forceString(query.record().value('Extr')))
        else:
            return None


    @staticmethod
    def getDiagnosForAction(db, actionId):
        stmt = """SELECT  `MKB` as ds
                    FROM  `Action`
                    WHERE  `id` = %s"""%(actionId)
        query = db.query(stmt)
        if query.next():
            return  (forceString(query.record().value('ds')))
        else:
            return None


    @staticmethod
    def isRegionalAdditionalPay(db, serviceCode):
        regionalAdditionalCode = ['3.14.1',
                                  '3.4.1',
                                  '4.3.1',
                                  '2.13.1',
                                  '1.4.1',
                                  '3.15.1',
                                  '1.3.1',
                                  '1.4.1',
                                  '1.4.1',
                                  '3.13.1',
                                  '2.10.1',
                                  '2.10.3',
                                  '2.23.2',
                                  '2.13.1',
                                  '2.3.1',
                                  '3.15.1']
        return True if serviceCode in regionalAdditionalCode else False


    @staticmethod
    def isNotUniqueEmergencyDayVisit(db, accountId, clientId, endDate):
        stmt = """SELECT MAX(Event.id) as eventId
                    FROM `Account_Item`
                    LEFT JOIN Event ON Event.id = `Account_Item`.`event_id`
                    WHERE `Account_Item`.master_id = %s AND Event.client_Id = %s  AND LEFT(Event.execDate,10) LIKE '%s'
                   --  GROUP BY date

                    HAVING COUNT(Event.id) > 1 -- AND MAX(Event.execDate)
                 --   ORDER BY Event.execDate
                --   LIMIT 1
                    """%(accountId, clientId, endDate.toString(Qt.ISODate))
        query = db.query(stmt)
        if query.next():
            return (forceRef(query.record().value('eventId')))
        else:
            return None


    @staticmethod
    def getActionForHealthCentr(db, accountId, eventId):
        stmt = """SELECT action_id  as actionId
                FROM  `Account_Item`
                    WHERE  `event_id` =%s AND master_id=%s"""%(eventId,accountId)
        query = db.query(stmt)
        buffer = []
        while query.next():
            print forceRef(query.record().value('actionId'))
            buffer.append(forceRef(query.record().value('actionId')))
        return buffer


    @staticmethod
    def getClientPolicy(db, clientId, eventBegDate, eventSetDate):
        stmt = """SELECT    ClientPolicy.serial AS policySerial,
                            ClientPolicy.number AS policyNumber,
                            rbPolicyKind.regionalCode AS policyKindCode,
                            Insurer.id as insurerId,
                            Insurer.miacCode as insurerMiac,
                            Insurer.OGRN AS insurerOGRN,
                            Insurer.OKATO AS insurerOKATO
                FROM  `ClientPolicy`
                LEFT JOIN Organisation AS Insurer ON Insurer.id = ClientPolicy.insurer_id
                LEFT JOIN rbPolicyKind ON ClientPolicy.policyKind_id = rbPolicyKind.id
                LEFT JOIN rbPolicyType AS CPT ON CPT.id = ClientPolicy.policyType_id
                WHERE  `client_id` =%s AND
                        ( `endDate` >=  '%s'
                            OR ClientPolicy.endDate IS NULL
                            OR ClientPolicy.endDate =  '0000-00-00')
                        AND  ClientPolicy.`deleted` =0
                        AND  '%s' >= ClientPolicy.begDate
                        AND ClientPolicy.insurer_id IS NOT NULL
                        AND CPT.code IN ('1','2')"""%(clientId, eventBegDate.toString(Qt.ISODate), eventSetDate.toString(Qt.ISODate))
        query = db.query(stmt)
        if query.next():
            return forceString(query.record().value(u'policyNumber'))[:20], forceString(query.record().value(u'policySerial'))[:10], forceString(query.record().value('policyKindCode'))[:1], forceString(query.record().value('insurerOGRN'))[:15], forceString(query.record().value('insurerOKATO'))[:5], forceString(query.record().value('insurerName'))[:100], forceString(query.record().value('insurerMiac'))[:5], forceString(query.record().value('insurerId'))
        else:
            return None, None, None, None, None, None, None, None


class PriceType:
    basePrice = 0
    federalPrice = 1
    regionalPrice = 2


class SummSingleton(object):
    _instance = None

    summTotal = 0.0
    dictSums = {1: 0.0}
    def __new__(cls, *args, **kwargs):
        if not cls._instance:
            cls._instance = super(SummSingleton, cls).__new__(
                                cls, *args, **kwargs)
        return cls._instance

