# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

#from PyQt4.QtCore import *

from library.interchange     import getCheckBoxValue, getLineEditValue, setCheckBoxValue, setLineEditValue
from library.ItemsListDialog import CItemsListDialog, CItemEditorBaseDialog
from library.TableModel      import CBoolCol, CTextCol
from RefBooks.Tables         import rbAccountingSystem, rbCode, rbName

from RefBooks.Ui_RBAccountingSystemEditor import Ui_ItemEditorDialog

class CRBAccountingSystemList(CItemsListDialog):
    def __init__(self, parent):
        CItemsListDialog.__init__(self, parent, [
            CTextCol(u'Код',          [rbCode], 10),
            CTextCol(u'Наименование', [rbName], 50),
            CTextCol(u'URN',          ['urn'],  50),
            CBoolCol( u'Разрешать изменение',         ['isEditable'], 30),
            CBoolCol( u'Отображать в информации о пациенте',         ['showInClientInfo'], 20),
            CBoolCol( u'Требует ввода уникального значения',         ['isUnique'], 20),
            ], rbAccountingSystem, [rbCode, rbName])
        self.setWindowTitleEx(u'Внешние учётные системы')

    def getItemEditor(self):
        return CRBAccountingSystemEditor(self)


class CRBAccountingSystemEditor(CItemEditorBaseDialog, Ui_ItemEditorDialog):
    def __init__(self,  parent):
        CItemEditorBaseDialog.__init__(self, parent, rbAccountingSystem)
        self.setWindowTitleEx(u'Внешняя учётная система')
        self.setupUi(self)
        self.setupDirtyCather()


    def setRecord(self, record):
        CItemEditorBaseDialog.setRecord(self, record)
        setLineEditValue( self.edtCode,             record, 'code')
        setLineEditValue( self.edtName,             record, 'name')
        setLineEditValue( self.edtUrn,              record, 'urn')
        setLineEditValue( self.edtVersion,          record, 'version')
        setLineEditValue( self.edtDomain,           record, 'domain')
        setCheckBoxValue( self.chkEditable,         record, 'isEditable')
        setCheckBoxValue( self.chkShowInClientInfo, record, 'showInClientInfo')
        setCheckBoxValue( self.chkIsUnique,         record, 'isUnique')


    def getRecord(self):
        record = CItemEditorBaseDialog.getRecord(self)
        getLineEditValue( self.edtCode,             record, 'code')
        getLineEditValue( self.edtName,             record, 'name')
        getLineEditValue( self.edtUrn,              record, 'urn')
        getLineEditValue( self.edtVersion,          record, 'version')
        getLineEditValue( self.edtDomain,           record, 'domain')
        getCheckBoxValue( self.chkEditable,         record, 'isEditable')
        getCheckBoxValue( self.chkShowInClientInfo, record, 'showInClientInfo')
        getCheckBoxValue( self.chkIsUnique,         record, 'isUnique')
        return record
