# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from library.interchange     import setDateEditValue, getDateEditValue
from library.ItemsListDialog import CItemsListDialog, CItemEditorDialog
from library.TableModel      import CTextCol, CDateCol
from Tables                  import rbCode, rbHealthGroup, rbName, rbBegDate, rbEndDate

from RefBooks.Ui_RBHealthGroupEditor import Ui_ItemEditorDialog


class CRBHealthGroupList(CItemsListDialog):
    def __init__(self, parent):
        CItemsListDialog.__init__(self, parent, [
            CTextCol(u'Код',            [rbCode],    20),
            CTextCol(u'Наименование',   [rbName],    40),
            CDateCol(u'Дата начала',    [rbBegDate], 20),
            CDateCol(u'Дата окончания', [rbEndDate], 20),
            ], rbHealthGroup, [rbCode, rbName, rbBegDate, rbEndDate])
        self.setWindowTitleEx(u'Группы здоровья')


    def getItemEditor(self):
        return CRBHealthGroupEditor(self)


class CRBHealthGroupEditor(Ui_ItemEditorDialog, CItemEditorDialog):
    def __init__(self,  parent):
        CItemEditorDialog.__init__(self, parent, rbHealthGroup)
        self.setWindowTitleEx(u'Группа здоровья')


    def setRecord(self, record):
        CItemEditorDialog.setRecord(self, record)
        setDateEditValue(self.edtBegDate, record, 'begDate')
        setDateEditValue(self.edtEndDate, record, 'endDate')


    def getRecord(self):
        record = CItemEditorDialog.getRecord(self)
        getDateEditValue(self.edtBegDate, record, 'begDate')
        getDateEditValue(self.edtEndDate, record, 'endDate')
        return record

