# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from library.interchange     import getLineEditValue, getRBComboBoxValue, setLineEditValue, setRBComboBoxValue
from library.ItemsListDialog import CItemsListDialog, CItemEditorBaseDialog
from library.TableModel      import CRefBookCol, CTextCol

from RefBooks.Tables         import rbCode, rbName, rbSocStatusType

from RefBooks.Ui_RBSocStatusTypeItemEditor import Ui_SocStatusTypeItemEditorDialog


class CRBSocStatusTypeList(CItemsListDialog):
    def __init__(self, parent):
        CItemsListDialog.__init__(self, parent, [
            CTextCol(u'Код',          [rbCode], 20),
            CTextCol(u'Наименование', [rbName], 40),
            CTextCol(u'Краткое наименование', ['shortName'], 40),
            CTextCol(u'Региональный код', ['regionalCode'], 20),
            CRefBookCol(u'Тип документа',['documentType_id'], 'rbDocumentType', 20)
            ], rbSocStatusType, [rbCode, rbName])
        self.setWindowTitleEx(u'Типы социального статуса')

    def getItemEditor(self):
        return CRBSocStatusTypeEditor(self)


class CRBSocStatusTypeEditor(CItemEditorBaseDialog,  Ui_SocStatusTypeItemEditorDialog):
    def __init__(self,  parent):
        CItemEditorBaseDialog.__init__(self, parent, rbSocStatusType)
        self.setupUi(self)
        self.setWindowTitleEx(u'Тип социального статуса')
        self.cmbDocumentType.setTable('rbDocumentType')
        self.setupDirtyCather()


    def setRecord(self, record):
        CItemEditorBaseDialog.setRecord(self, record)
        setLineEditValue(self.edtCode, record, 'code')
        setLineEditValue(self.edtName, record, 'name')
        setLineEditValue(self.edtShortName, record, 'shortName')
        setLineEditValue( self.edtRegionalCode, record, 'regionalCode')
        setRBComboBoxValue(self.cmbDocumentType, record, 'documentType_id')
        self.setIsDirty(False)


    def getRecord(self):
        record = CItemEditorBaseDialog.getRecord(self)
        getLineEditValue( self.edtCode,     record, 'code')
        getLineEditValue( self.edtName,     record, 'name')
        getLineEditValue( self.edtShortName, record, 'shortName')
        getLineEditValue( self.edtRegionalCode,  record, 'regionalCode')
        getRBComboBoxValue(self.cmbDocumentType, record, 'documentType_id')
        return record
