# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4 import QtGui
from library.Utils import forceRef, forceString

from Ui_ClientRecordProperties import Ui_ClientRecordProperties


class CRecordProperties(QtGui.QDialog, Ui_ClientRecordProperties):
    def __init__(self, parent, table, recordId=None):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)
        self.table = table
        self.recordId = recordId
        self.setWindowTitle(u'Свойства записи')


    def exec_(self):
        self.setInfo()
        return QtGui.QDialog.exec_(self)


    def setInfo(self):
        if self.recordId is not None:
            text = u''
            db = QtGui.qApp.db
            record = db.getRecord(self.table, '*', self.recordId)
            createPersonId = forceRef(record.value('createPerson_id'))
            createPersonName = ''
            if createPersonId:
                createPersonRecord = db.getRecord('vrbPersonWithSpeciality', '*', createPersonId)
                if createPersonRecord:
                    createPersonName = forceString(createPersonRecord.value('name'))
            text += u'Создатель записи: %s\n'%createPersonName
            createDatetime = forceString(record.value('createDatetime'))
            createDatetime = createDatetime if createDatetime else ''
            text += u'Дата создания записи: %s\n'%createDatetime
            modifyPersonId = forceRef(record.value('modifyPerson_id'))
            modifyPersonName = ''
            if modifyPersonId:
                modifyPersonRecord = db.getRecord('vrbPersonWithSpeciality', '*', modifyPersonId)
                if modifyPersonRecord:
                    modifyPersonName = forceString(modifyPersonRecord.value('name'))
            text += u'Редактор записи: %s\n'%modifyPersonName
            modifyDatetime = forceString(record.value('modifyDatetime'))
            modifyDatetime = modifyDatetime if modifyDatetime else ''
            text += u'Дата редактирования записи: %s\n'%modifyDatetime
            self.edtInfo.setText(text)


