# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4 import QtGui
from PyQt4.QtCore import pyqtSignature, QDate

from Reports.Ui_Report131_1000Setup import Ui_Report131_1000SetupDialog


class CReportForm131_1000_SetupDialog(QtGui.QDialog, Ui_Report131_1000SetupDialog):
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)
        self.cmbFilterContingentType.setTable('rbContingentType', addNone=True)
        self.cmbOrgStructure.setOrgId(QtGui.qApp.currentOrgId())
        self.cmbOrgStructure.setValue(QtGui.qApp.currentOrgStructureId())


    def setTitle(self, title):
        self.setWindowTitle(title)


    def setParams(self, params):
        self.edtBegDate.setDate(params.get('begDate', QDate.currentDate()))
        self.edtEndDate.setDate(params.get('endDate', QDate.currentDate()))
        self.cmbFilterContingentType.setValue(params.get('contingentTypeId', None))
        self.chkAttache.setChecked(params.get('isAttache', True))
        self.cmbOrgStructure.setValue(params.get('orgStructureId', None))


    def params(self):
        result = {}
        result['begDate'] = self.edtBegDate.date()
        result['endDate'] = self.edtEndDate.date()
        result['orgStructureId'] = self.cmbOrgStructure.value()
        result['contingentTypeId'] = self.cmbFilterContingentType.value()
        result['isAttache'] = self.chkAttache.isChecked()
        result['orgId'] = self.cmbOrgStructure.model().orgId
        return result


    @pyqtSignature('int')
    def on_cmbFilterContingentType_currentIndexChanged(self, index):
        contingentTypeId = self.cmbFilterContingentType.value()
        stringInfo = u'Введите тип контингента' if not contingentTypeId else u''
        self.cmbFilterContingentType.setToolTip(stringInfo)
        self.buttonBox.button(QtGui.QDialogButtonBox.Ok).setEnabled(bool(contingentTypeId))

