# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

import hashlib

from PyQt4 import QtGui

from library.Utils  import forceString, forceStringEx

from Users.Tables   import demoUserName, tblUser, usrId, usrLogin, usrPassword, usrRetired

from Users.Ui_Login import Ui_LoginDialog


class CLoginDialog(QtGui.QDialog, Ui_LoginDialog):
    def __init__(self, parent):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)
        self._userId = None
        self._demoMode = False


    def accept(self):
        try:
            login    = forceStringEx(self.edtLogin.text())
            password = forceString(self.edtPassword.text())

            if login != '':
                db = QtGui.qApp.db
                tableUser = QtGui.qApp.db.table(tblUser)

                # фантазия на тему challenge-response
                # с одним усложнением - в базе храним
                # пароли хешированные md5
                # таким образом мы нигде не передаём пароль в открытом виде.
                if db.name == 'mysql':
                    db.query('SET @USTS = CONCAT(NOW(), RAND())')
                    ustsQuery = db.query('SELECT @USTS')
                    ustsQuery.first()
                    ustsRecord = ustsQuery.record()
                    usts = forceString(ustsRecord.value(0))
                    encodedPassword = unicode(password).encode('utf8')
                    hashedPassword = hashlib.md5(encodedPassword).hexdigest()

                    cond = [ tableUser[usrLogin].eq(login),
                             ('MD5(CONCAT(@USTS,' + usrPassword +'))=\'%s\'') % hashlib.md5(usts+hashedPassword).hexdigest(),
                             tableUser[usrRetired].eq(False),
                             tableUser['deleted'].eq(False),
                             '(Person.retireDate IS NULL OR Person.retireDate > CURDATE())'
                           ]
                else:
                    #TODO: придумать что то для посгри
                    encodedPassword = unicode(password).encode('utf8')
                    hashedPassword = hashlib.md5(encodedPassword).hexdigest()

                    cond = [ tableUser[usrLogin].eq(login),
                             ('MD5(' + usrPassword +')=\'%s\'') % hashlib.md5(hashedPassword).hexdigest(),
                             tableUser[usrRetired].eq(False),
                             tableUser['deleted'].eq(False),
                             '(Person.retireDate IS NULL OR Person.retireDate > current_date)'
                           ]
                userIdList = db.getIdList(tableUser, usrId, cond, [usrId])
                if len(userIdList) == 1:
                    self._userId = userIdList[0]
                    self._demoMode = False
                    QtGui.QDialog.accept(self)
                    return
                if login == demoUserName and password == '' and QtGui.qApp.demoModePosible():
                    self._userId = None
                    self._demoMode = True
                    QtGui.QDialog.accept(self)
                    return
            QtGui.QMessageBox.critical( self,
                                        u'Внимание',
                                        u'Имя пользователя или пароль неверны',
                                        QtGui.QMessageBox.Close)
        except Exception, e:
            QtGui.QMessageBox.critical( self,
                                        u'',
                                        unicode(e),
                                        QtGui.QMessageBox.Close)


    def userId(self):
        return self._userId


    def demoMode(self):
        return self._demoMode


    def setLoginName(self, loginName):
        self.edtLogin.setText(loginName)


    def loginName(self):
        return unicode(self.edtLogin.text())
