<?php
##############################################################################
##
## Функция форматирования SNILS
##
##############################################################################
##
## Copyright (C) 2014 SAMSON Group. All rights reserved.
##
##############################################################################
##
##  $LastChangedBy: vadim $
##  $LastChangedDate: 2015-05-14 17:37:37 +0300 (Thu, 14 May 2015) $
##  $Revision: 14332 $
##
##############################################################################

function formatSNILS($aCompactSNILS)
{
    if ( !$aCompactSNILS )
        return '';

    #   123456789AB ->  123-456-789 AB
    return sprintf('%0-3.3s-%0-3.3s-%0-3.3s %0-2.2s',
                   substr($aCompactSNILS, 0, 3),
                   substr($aCompactSNILS, 3, 3),
                   substr($aCompactSNILS, 6, 3),
                   substr($aCompactSNILS, 9, 2)
                 );
}


function calcSNILSCheckCode($aCompactSNILS)
{
    $vSum = 0;
    for( $i=0; $i<9; $i++ )
    {
        $vSum += (9-$i)*intval( $aCompactSNILS[$i] );
    }
    $vSum = ($vSum % 101) % 100;
    return sprintf('%02.2d', $vSum);
}

function checkCompactSNILS($aCompactSNILS)
{
    return    strlen($aCompactSNILS) == 11 
           && (    substr($aCompactSNILS, 0, 9) <= '001001998' 
                || substr($aCompactSNILS, -2) === calcSNILSCheckCode($aCompactSNILS)
              );
}

function unformatSNILS($aSnils)
{
    if ( !$aSnils )
        return '';

    $vCompactSnils = preg_replace('/\\D/', '', $aSnils);
    return $vCompactSnils;
}
/*
function test($us)
{
   $fs = formatSNILS($us);
   print_r(array($fs, unformatSNILS($fs), calcSNILSCheckCode($us), checkCompactSNILS($us)));
}

test('00100199812'); // ok
test('00100199813'); // ok
test('00100199913'); // not ok
test('00100199965'); // ok
test('00160674500'); // ok
test('00156084099'); // ok
*/
?>
