# -*- coding: utf-8 -*-
#############################################################################

from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from library.Utils     import *

class CXmlWriter(QXmlStreamWriter):
    def __init__(self, parent, xmlFile):
        QXmlStreamWriter.__init__(self)
        self.parent = parent
        self.setAutoFormatting(True)
        self.setDevice(xmlFile)
        self.setCodec(QtCore.QTextCodec.codecForName('cp1251'))

    def writeRecord(self, record):
        self.writeStartElement('REC')
        self.writeTextElement('N_REC', '%d' % forceInt(record.value('externalId')))
        self.writeTextElement('FAM', forceString(record.value('lastName')).strip())
        self.writeTextElement('IM', forceString(record.value('firstName')).strip())
        self.writeTextElement('OT', forceString(record.value('patrName')).strip())
        self.writeTextElement('W', forceString(record.value('sex')).strip())
        self.writeTextElement('DR', str(forceDate(record.value('birthDate')).toPyDate()).strip())
        self.writeTextElement('VPOLIS', forceString(record.value('policyKind')))
        if forceString(record.value('serial')):
            self.writeTextElement('SPOLIS', forceString(record.value('serial')))
        self.writeTextElement('NPOLIS', forceString(record.value('number')))
        self.writeTextElement('REQ_NUM', '%d_%d' % (forceInt(record.value('clientId')), (forceInt(record.value('clientAttachId')))))
        self.writeTextElement('REQ_DATE', str(forceDate(record.value('dateAttach')).toPyDate()))
        self.writeTextElement('V_PR', u'1')
        self.writeEndElement()

    def writeHeader(self, version, organizationCode, settleDate, shortFileName):
        self.writeStartDocument()
        self.writeStartElement('RPN')
        self.writeStartElement('ZGLV')
        self.writeTextElement('VERSION', version)
        self.writeTextElement('CODE_ORG', organizationCode)
        self.writeTextElement('DATA', str(settleDate.toPyDate()))
        self.writeTextElement('FILENAME', shortFileName)
        self.writeEndElement() #ZGLV
        self.writeStartElement('RECS')

    def writeFooter(self):
        self.writeEndElement() #RECS
        self.writeEndElement() #RPN
        self.writeEndDocument()