# -*- coding: utf-8 -*-
from PyQt4 import QtGui
from library.Utils import *
from appendix.regional.r29.exportAttached.Common.DbMethods import *
from appendix.regional.r29.exportAttached.Import.XmlReaders.NfReader import *
from appendix.regional.r29.exportAttached.Import.XmlReaders.NpReader import *
from appendix.regional.r29.exportAttached.Import.XmlReaders.NrReader import *


class CImportHelper(object):
    def __init__(self, headerId):
        self.headerId = headerId
        self.db = QtGui.qApp.db

    def setReader(self, fileName):
        self.fileName = fileName
        if os.path.basename(forceString(fileName)).startswith(u'NF'):
            self.reader = CNfReader(self.fileName)
        elif os.path.basename(forceString(fileName)).startswith(u'NP'):
            self.reader = CNpReader(self.fileName)
        elif os.path.basename(forceString(fileName)).startswith(u'NR'):
            self.reader = CNrReader(self.fileName)
        else:
            raise Exception(u'Недопустимый тип файла')

    def setSender(self, sender):
        self.sender = sender

    def _getSupposedFileName(self, prefix, headerId):
        creationDate = forceDate(getHeaderCreationDateTime(self.db, headerId))
        yearStr = str(creationDate.toPyDate().year)[2:4]
        monthStr = str(creationDate.toPyDate().month).zfill(2)
        registryNn = forceString(self.db.translate('ExportAttachHeader', 'id', self.headerId, 'number'))
        infis = forceString(getCurrentInfis(self.db))
        xmlFileName = u'%s_%s_%s%s%s' % (prefix, infis, yearStr, monthStr, registryNn)
        return xmlFileName

    def _checkFileName(self, prefix):
        return self._getSupposedFileName(prefix, self.headerId) == os.path.splitext(os.path.basename(unicode(self.fileName)))[0]
