# -*- coding: utf-8 -*-
from appendix.regional.r29.exportAttached.Common.DbMethods import *
from appendix.regional.r29.exportAttached.Import.ImportHelpers.ImportHelper import *
from appendix.regional.r29.exportAttached.Import.XmlReaders.NfReader import CNfReader


class CImportHelperNf(CImportHelper):
    def go(self):
        self.reader.open()
        if not self._checkFileName('NF'):
            self.sender.logMessage(u'Неверное имя файла! Ожидается: %s' % self._getSupposedFileName('NF', self.headerId))
            return
        try:
            (code, message) = self._updateDbHeader()
            self._processItems()
            if code not in (1, 2):
                self._markUnprocessedItems()
            if code != 0:
                self.sender.logMessage(u'Импорт прошел с ошибками:')
                self.sender.logMessage(u'%s: %s' % (code, message))
        except Exception, e:
           self.sender.logMessage(e)

#TODO: Move into dbmethods
    def _updateDbHeader(self):
        header = self.reader.readNfHeader()
        stmt = """UPDATE ExportAttachHeader
                  SET
                  code = %d,
                  message = '%s'
                  WHERE id = %d
                  """ % (header.result, header.comment, self.headerId)
        safelyExecute(self.db, stmt)
        return forceInt(header.result), header.comment

    def _processItems(self):
        while not self.reader.atEnd():
            self.sender.progressBar.step()
            item = self.reader.readNextBlock()
            if item:
                if itemExistsInRegistry(self.db, item.externalId, self.headerId):
                    self._updateItem(item.externalId, self.headerId, item.errorCode, item.comment)
                else:
                    self.sender.logMessage(item.externalId + u'заись не найдена в реестре')

    def _updateItem(self, externalId, headerId, code, message):
        updateExportItem(self.db, externalId, headerId, 'code', code)
        updateExportItem(self.db, externalId, headerId, 'message', message)

    def _markUnprocessedItems(self):
        updateExportItemCondition(self.db, self.headerId, u"""code = 0, message = 'без ошибок'""", 'code IS NULL')