# -*- coding: utf-8 -*-

from appendix.regional.r29.exportAttached.Import.XmlReaders.NpReader import *
from appendix.regional.r29.exportAttached.Import.ImportHelpers.ImportHelper import *
import datetime
from appendix.regional.r29.exportAttached.Common.Rbs import *


class CImportHelperNp(CImportHelper):
    def go(self):
        self.reader.open()
        if not self._checkFileName('NP'):
            self.sender.logMessage(u'Неверное имя файла! Ожидается: %s' % self._getSupposedFileName('NP', self.headerId))
            return

        while not self.reader.atEnd():
            QtGui.qApp.processEvents()
            result = self.reader.readNextBlock()
            if result:
                (externalId, codeMo, dateReg, result, comment) = result 
            else:
                break
            
            self.sender.progressBar.step()
            if not itemExistsInRegistry(self.db, externalId, self.headerId):
                self.sender.logMessage(externalId, u'Запись не найдена в реестре')
                continue
            if result == 0:
                self.sender.logMessage(NpResultCodes[result], externalId)
                setErrorState(self.db, self.headerId, externalId, result, NpResultCodes[result])
#                continue
            elif result < 3:
                self.sender.logMessage(NpResultCodes[result], externalId)
                setErrorState(self.db, self.headerId, externalId, result, NpResultCodes[result])
                #TODO: continue или нет?
#                continue
            elif result == 4:
                self.sender.logMessage(NpResultCodes[result], externalId)
                setErrorState(self.db, self.headerId, externalId, result, comment)
            else:
                self.sender.logMessage(comment, externalId)
                setErrorState(self.db, self.headerId, externalId, result, NpResultCodes[result])

            #Это тот случай, если только сообщение с кодом в записи, без деталей.
            if not codeMo or dateReg:
                continue

            itemRecord = getExportItemRecord(self.db, externalId, self.headerId)
            clientId = forceInt(itemRecord.value('clientId'))
            clientAttachId = forceInt(itemRecord.value('clientAttachId'))

            if not checkAttachmentOrganisation(self.db, clientAttachId, codeMo):
                setErrorState(self.db, self.headerId, externalId, -1,
                                    u'Код МО не совпадает с инфис организации в реестре...')
                self.sender.logMessage(externalId, u'Код МО не совпадает с инфис организации в реестре...')
                closeClientsAttaches(self. db, clientId,
                                     dateReg - datetime.timedelta(days=2))
                self.sender.logMessage(externalId, u'-> проставлены даты окончания: %s' % self.db.formatDate(dateReg))
                insertNewClientAttach(self.db, clientId,
                                      dateReg - datetime.timedelta(days=1),
                                      codeMo)
                self.sender.logMessage(externalId, u'-> создаем новую сущность с типом прикрепления "Территориальный"')
