# -*- coding: utf-8 -*-
from PyQt4 import QtGui
from appendix.regional.r29.exportAttached.Import.ImportHelpers.ImportHelper import *
from appendix.regional.r29.exportAttached.Common.Rbs import *

class CImportHelperNr(CImportHelper):
    def __init__(self, headerId):
        super(CImportHelperNr, self).__init__(headerId)
        self.db = QtGui.qApp.db

    def go(self):
        self.reader.open()
        date, filename = self._getNrFileHeader()
        headerId = self._insertNrHeader(date, filename)
        QtGui.qApp.logCurrentException()
        self._processClients(headerId)

    def _getNrFileHeader(self):
        return self.reader.readFileHeader()

    def _insertNrHeader(self, date, fileName):
        tableHeader = self.db.table('ExportAttachHeader')
        tableHeader.setIdFieldName('id')
        record = tableHeader.newRecord()
        record.setValue('settleDate', None)
        record.setValue('fromDate', None)
        record.setValue('createDatetime', date)
        record.setValue('number', '')
        record.setValue('comment', fileName)
        record.setValue('filter', '')
        return self.db.insertRecord(tableHeader, record)

    def _insertNrItem(self, headerId, client, clientAttachId, code, message):
        tableItem = self.db.table('ExportAttachItem')
        tableItem.setIdFieldName('id')
        record = tableItem.newRecord()
        record.setValue('clientId', client.dbClientId)
        record.setValue('clientAttachId', clientAttachId)
        record.setValue('lastName', client.lastName)
        record.setValue('firstName', client.firstName)
        record.setValue('patrName', client.patrName)
        record.setValue('birthDate', client.birthDate)
        record.setValue('sex', forceInt(client.sex))
        record.setValue('policyKind', client.policy.version)
        record.setValue('serial', client.policy.oldSerial)
        record.setValue('number', client.policy.oldNumber)
        record.setValue('dateAttach', '')
        record.setValue('headerId', headerId)
        record.setValue('externalId', client.externalId)
        record.setValue('code', code)
        record.setValue('message', message)
        self.db.insertRecord(tableItem, record)

    def _processClients(self, headerId):
        count = 0
        while not self.reader.atEnd():
            QtGui.qApp.processEvents()
            try:
                self.sender.progressBar.step()
                client = self.reader.readNextBlock()
                (clientId, serial, number, unifiedNumber) = getClientDbId(self.db, client)
                client.dbClientId = clientId
                code = 100
                if not clientId:
                    code = 101
                else:
                    if not unifiedNumber:
                        if not client.policy.unifiedNumber:
                            if client.policy.oldNumber and client.policy.oldSerial and serial and number:
                                if client.policy.oldSerial != serial or client.policy.oldNumber != number:
                                    code = 102
                            else:
                                code = 102
                        else:
                            code = 102

                    else:
                        if (not client.policy.unifiedNumber) or (unifiedNumber != client.policy.unifiedNumber):
                            code = 102
                attachType = getClientLastAttachType(self.db, client.dbClientId)

                if attachType != 2 or not attachType:
                    code = 103
                count += 1

            except Exception, e:
                self.sender.logMessage(e)

            if code != 100:
                self.sender.logMessage(NrItemCodes[code] + client.unicode())
            self._insertNrItem(headerId, client, None, code, NrItemCodes[code])
        self.updateHeaderCount(count, headerId)

    def updateHeaderCount(self, count, headerId):
            stmt = """UPDATE ExportAttachHeader SET count = %d WHERE id = %d""" % (count, headerId)
            safelyExecute(self.db, stmt)
