﻿# -*- coding: utf-8 -*-
from PyQt4 import QtGui
from PyQt4 import QtCore
from library.Utils import anyToUnicode
from Ui_ImportVisualisation import Ui_Dialog

class CImportVisualisation(QtGui.QDialog, Ui_Dialog):
    def __init__(self, parent, importHelper, title=u'Выбор файла'):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)
        self.importHelper = importHelper
        self.importRun = False
        self.abort = False
        self._resetContent(title)

    def _resetContent(self, title):
        self.progressBar.reset()
        self.log.clear()
        self.setWindowTitle(title)

    def logMessage(self, message, eid=None):
        if eid:
            self.log.append(u'запись %s %s' % (eid, message))
        else:
            self.log.append(u'%s' % message)

    @QtCore.pyqtSignature('')
    def on_btnSelectFile_clicked(self):
        fileName = QtGui.QFileDialog.getOpenFileName(
            self, u'Укажите файл с данными', self.edtFileName.text(), u'Файлы XML (*.xml)|Архивы (*.zip)|Все файлы *')
        if fileName != '':
            self.edtFileName.setText(QtCore.QDir.toNativeSeparators(fileName))
            self.btnImport.setEnabled(True)

    @QtCore.pyqtSignature('')
    def on_btnClose_clicked(self):
        if self.importRun:
            self.abort = True
        else:
            self.close()

    @QtCore.pyqtSignature('')
    def on_btnImport_clicked(self):
        self.btnImport.setEnabled(False)
        self.btnClose.setText(u'Прервать')
        self.abort = False
        self.importRun = True
        try:
            self.importHelper.setReader(self.edtFileName.text())
            self.progressBar.setMaximum(self.importHelper.reader.numberOfRecords)
            self.importHelper.go()
        except IOError, e:
            QtGui.qApp.logCurrentException()
            msg=''
            if hasattr(e, 'filename'):
                msg = u'%s:\n[Errno %s] %s' % (e.filename, e.errno, anyToUnicode(e.strerror))
            else:
                msg = u'[Errno %s] %s' % (e.errno, anyToUnicode(e.strerror))
            QtGui.QMessageBox.critical(self, u'Произошла ошибка ввода-вывода', msg, QtGui.QMessageBox.Close)
        except Exception, e:
            QtGui.qApp.logCurrentException()
            QtGui.qApp.db.rollback()
            QtGui.QMessageBox.critical(self, u'Произошла ошибка', unicode(e), QtGui.QMessageBox.Close)
            self.abort = True
        if self.progressBar:
            self.progressBar.setValue(0)
            self.progressBar.setFormat(u'прервано' if self.abort else u'готово')
        self.btnImport.setEnabled(True)
        self.btnClose.setText(u'Закрыть')
        self.abort = False
        self.importRun = False
