from appendix.regional.r29.exportAttached.Import.XmlReaders.XMLReader import CXmlReader
from appendix.regional.r29.exportAttached.Common.Describers import *
from appendix.regional.r29.exportAttached.Common.Rbs import *


class CNfReader(CXmlReader):
    fieldsNfHeader = ('FLK_RES', 'COMMENT_RES')
    fieldsNf = ('N_REC', 'OSHIB', 'COMMENT')

    def __init__(self, fileName):
        CXmlReader.__init__(self, fileName)
        self._countRecords('PR')

    def open(self):
        self._openFile()

    def readNfHeader(self):
        contentHeader = self. _readTagsFirstAppearance(self.fieldsNfHeader)
        if not 'COMMENT_RES' in contentHeader:
            contentHeader['COMMENT_RES'] = NfHeaderCodes[forceInt(contentHeader['FLK_RES'])]
        return ExportHeaderDescriber(forceInt(contentHeader['FLK_RES']), contentHeader['COMMENT_RES'])

    def readNextBlock(self):
        self._seekToTag('PR')
        contentNf = self._readGroup('PR', self.fieldsNf)
        return ExportItemDescriber(forceInt(contentNf['N_REC']), forceInt(contentNf['OSHIB']), forceString(contentNf['COMMENT']))
