from appendix.regional.r29.exportAttached.Import.XmlReaders.XMLReader import CXmlReader
from appendix.regional.r29.exportAttached.Common.Describers import *
from datetime import datetime


class CNpReader(CXmlReader):
    fieldsNp = ('N_REC', 'CODE_MO', 'RESULT', 'COMMENT', 'DATE_REG')

    def open(self):
        self._openFile()

    def __init__(self, fileName):
        CXmlReader.__init__(self, fileName)
        self._countRecords('REC')

    def readNextBlock(self):
        self._seekToTag('REC')
        contentNp = self._readGroup('REC', self.fieldsNp)
        if not contentNp:
            return None
        comment = u''
        if ('RESULT' in contentNp) and ('COMMENT' in contentNp):
            comment = forceString(contentNp['COMMENT'])

        code_mo = None
        if 'CODE_MO' in contentNp:
            code_mo = forceString(contentNp['CODE_MO'])

        date_reg = None
        if 'DATE_REG' in contentNp:
            date_reg = datetime.strptime(forceString(contentNp['DATE_REG']), '%Y-%m-%d').date()

        return forceInt(contentNp['N_REC']), \
               code_mo, \
               date_reg, \
               forceInt(contentNp['RESULT']), \
               comment