from appendix.regional.r29.exportAttached.Import.XmlReaders.XMLReader import CXmlReader
from appendix.regional.r29.exportAttached.Common.Describers import *
from library.Utils import *


class CNrReader(CXmlReader):
    fieldsPerson = ('N_REC', 'FAM', 'IM', 'OT', 'W', 'DR', 'VPOLIS', 'SPOLIS', 'NPOLIS', 'RESULT')

    fieldsPolicy = {'REG': ('ENP', 'SMOCOD', 'CODE_MO', 'DATE_REG')}

    def __init__(self, fileName):
        CXmlReader.__init__(self, fileName)
        self._countRecords('REC')

    def open(self):
        self._openFile()

    def getRegistryNumber(self):
        #TODO: process filename
        return 0

    def readFileHeader(self):
        result = self._readGroup('ZGLV', ('DATA', 'FILENAME'))
        return QDate().fromString(forceString(result['DATA']), "yyyy-MM-dd"), forceString(result['FILENAME'])

    def _readBlock(self):
        assert self.isStartElement() and self.name() == 'REC'
        content = self._readGroupsInside('REC', ('REG',), self.fieldsPerson, self.fieldsPolicy)
        externalId = forceInt(content['REC']['N_REC'])
        lastName = forceString(content['REC']['FAM'])
        firstName = forceString(content['REC']['IM'])
        patrName = forceString(content['REC']['OT'])
        sex = forceInt(content['REC']['W'])
        birthDate = QDate().fromString(forceString(content['REC']['DR']), "yyyy-MM-dd")
        client = ClientDescriber()
        version = None
        oldSerial = None
        oldNumber = None
        if 'VPOLIS' in content['REC']:
            version = forceString(content['REC']['VPOLIS'])
        if 'SPOLIS' in content['REC']:
            oldSerial = forceString(content['REC']['SPOLIS'])
        if 'NPOLIS' in content['REC']:
            oldNumber = forceString(content['REC']['NPOLIS'])
        policy = PolicyDescriber(version, oldSerial, oldNumber, content['REG']['ENP'], content['REG']['SMOCOD'], content['REG']['CODE_MO'], content['REG']['DATE_REG'])
        client.setFields(externalId, lastName, firstName, patrName, sex, birthDate, policy)
        return client

    def readNextBlock(self):
        self._seekToTag('REC')
        client = self._readBlock()
        return client