# -*- coding: utf-8 -*-
from PyQt4.QtCore import *
from library.Utils import *
import os
import shutil
import zipfile


class CXmlReader(QXmlStreamReader):
    def __init__(self, fileName):
        QXmlStreamReader.__init__(self)
        if fileName.endsWith('.zip'):
            self.fileName = self.ExtractZipFile(fileName)
        else:
            self.fileName = fileName

    def ExtractZipFile(self, zipFIleName):
        with zipfile.ZipFile(unicode(zipFIleName)) as zip_file:
            for member in zip_file.namelist():
                filename = os.path.basename(member)
                if not filename:
                    continue
                source = zip_file.open(member)
                self.tmpPath = QtGui.qApp.getTmpDir('import')
                targetPath = os.path.join(self.tmpPath, filename)
                target = file(targetPath, "wb")
                with source:
                    with target:
                        shutil.copyfileobj(source, target)
                return targetPath

    def _countRecords(self, tagName):
        count = 0
        with open(r'%s' % unicode(self.fileName), mode='r') as f:
            for line in f:
                count += line.count('<%s>' % tagName)
        self.numberOfRecords = count

    def _openFile(self):
        assert self.fileName
        self.xmlFile = QFile(self.fileName)
        self.xmlFile.open(QIODevice.ReadOnly)
        self.setDevice(self.xmlFile)

    def _seekToTag(self, tagName):
        if (self.name() == tagName and self.isStartElement()) or self.atEnd():
            return
        while not (self.isStartElement() and self.name() == tagName) and not self.atEnd():
            self.readNext()

    def _readGroup(self, groupName, fieldsList):
#        assert self.isStartElement() and self.name() == groupName
        if self.atEnd():
            return None
        result = {}
        while not (self.isEndElement() and self.name() == groupName):
            if self.name() in fieldsList:
                result[forceString(self.name())] = forceString(self.readElementText())
            self.readNext()
            if self.isEndDocument() or len(result) == len(fieldsList):
                break
        return result

    def _readGroupsInside(self, mainGroupName, innerGroupsList, mainGroupFieldList, innerGroupsFieldLists):
        if self.atEnd():
            return None
        result = {mainGroupName: {}}
        #читаем группу-контейнер
        while not (self.isEndElement() and self.name() == mainGroupName):
            if self.name() in innerGroupsList:
                groupName = forceString(self.name())
                innerGroupContents = self._readGroup(groupName, innerGroupsFieldLists[groupName])
                result[groupName] = innerGroupContents
            if self.name() in mainGroupFieldList:
                name = forceString(self.name())
                result[mainGroupName][name] = forceString(self.readElementText())
            self.readNext()
            if self.isEndDocument():
                break
        return result

    def _readTagsFirstAppearance(self, fieldList):
        result = {}
        #TODO: затребовать с ФОМС новую спецификацию!!!
        field = 'FLK_RES'
#        for field in fieldList:
        self._seekToTag(field)
        result[field] = forceString(self.readElementText())
        return result

    def abort(self):
        pass

    def __exit__(self, exc_type, exc_val, exc_tb):
        for fileInstance in os.listdir(self.tmpPath):
            filePath = os.path.join(self.tmpPath, fileInstance)
            try:
                if os.path.isfile(filePath):
                    os.unlink(filePath)
            except Exception, e:
                print e