# -*- coding: utf-8 -*-
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui  import *
from Users.Login         import CLoginDialog
from Users.Rights        import *
from library             import database
from library.Utils       import *
from preferences.connection import CConnectionDialog
from preferences.decor import CDecorDialog
from preferences.appPreferencesDialog   import CAppPreferencesDialog
from appendix.regional.r29.exportAttached.Export.ExportAttach import *
from appendix.regional.r29.exportAttached.Export.FormExportData import CFormExportData
from Ui_MainWindow import Ui_MainWindow
from appendix.regional.r29.exportAttached.Common.Models import CHeaderModel
from appendix.regional.r29.exportAttached.Common.Models import CItemModel
from appendix.regional.r29.exportAttached.Import.ImportHelpers.ImportHelperNf import CImportHelperNf
from appendix.regional.r29.exportAttached.Import.ImportHelpers.ImportHelperNp import CImportHelperNp
from appendix.regional.r29.exportAttached.Import.ImportHelpers.ImportHelperNr import CImportHelperNr
from appendix.regional.r29.exportAttached.Import.ImportVisualisation import CImportVisualisation
from Registry.ClientEditDialog import CClientEditDialog
try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    _fromUtf8 = lambda s: s

# #############################################################


class chkAttachType(QtGui.QCheckBox, object):
    def __init__(self, itemid):
        self.id = itemid
        super(chkAttachType, self).__init__()

    def getId(self):
        return self.id


class CMainWindow(QtGui.QMainWindow, Ui_MainWindow):
    def __init__(self, db = None, parent=None):
        QtGui.QMainWindow.__init__(self, parent)
        self._setupUi()
        self.db = db
        self.formExportData = None
        self.checks = []
        self.loadPreferences()
        self.chkBoxAll = QCheckBox(self.gbChkSelect)
        self.chkBoxAll.setGeometry(10, 15, 120, 45)
        self.chkBoxAll.setText(QtGui.QApplication.translate("MainWindow", u"Выбрать все", None, QtGui.QApplication.UnicodeUTF8))
        self.chkBoxAll.setObjectName(_fromUtf8("chkSelectAll"))
        self.connect(self.chkBoxAll, SIGNAL("stateChanged(int)"), self._checkAllCalled)
        self.chkBoxInvert = QCheckBox(self.gbChkSelect)
        self.chkBoxInvert.setGeometry(110, 15, 220, 45)
        self.chkBoxInvert.setText(QtGui.QApplication.translate("MainWindow", u"Инвертировать выбор", None, QtGui.QApplication.UnicodeUTF8))
        self.chkBoxInvert.setObjectName(_fromUtf8("chkSelectInvert"))
        self.connect(self.chkBoxInvert, SIGNAL("stateChanged(int)"), self._checkInvertCalled)
        self.tblItems.currentClientId = None

    def _addModels(self, name, model):
        modelName = 'model'+name
        self.__setattr__(modelName, model)
        model.setObjectName(modelName)
        selectionModelName = 'selectionModel'+name
        selectionModel = QtGui.QItemSelectionModel(model, self)
        self.__setattr__(selectionModelName, selectionModel)
        selectionModel.setObjectName(selectionModelName)

    def _setupUi(self):
        super(CMainWindow,self).setupUi(self)
        yesterday = QDate.currentDate().addDays(-1)
        self.clnCalcCalendar.setSelectedDate(yesterday)
        self.progressBar.setProperty("value", 0)

    def checkConstrain(self, cond, message):
        if not cond:
            QtGui.QMessageBox.critical(
                self,
                u'Импорт невозможен',
                message,
                QtGui.QMessageBox.Close)
        return cond

    def setDb(self, db):
        self.db = db

    def loadDatabaseData(self):
        self.formExportData = CFormExportData()
        self.loadAttachTypes()
        self.fillTables()

    def upgradeCurrentRow(self):
        pass

    def addPopupDelRow(self, tbl):
        tbl._actDeleteRow = QtGui.QAction(u'Удалить запись', tbl)
        tbl._actDeleteRow.setObjectName('actDeleteRow')
        tbl.connect(tbl._actDeleteRow, QtCore.SIGNAL('triggered()'), self.removeCurrentHeaderRow)
        tbl.addPopupAction(tbl._actDeleteRow)

    def addPopupDelItemRow(self, tbl):
        tbl._actDeleteItemRow = QtGui.QAction(u'Удалить запись', tbl)
        tbl._actDeleteItemRow.setObjectName('actDeleteItemRow')
        tbl.connect(tbl._actDeleteItemRow, QtCore.SIGNAL('triggered()'), self.removeSelectedItemRows)
        tbl.addPopupAction(tbl._actDeleteItemRow)

    def addPopupUpgradeRow(self, tbl):
        tbl._actUpgradeRow = QtGui.QAction(u'Обновить из файла', tbl)
        tbl._actUpgradeRow.setObjectName('actUpgradeRow')
        tbl.connect(tbl._actUpgradeRow, QtCore.SIGNAL('triggered()'), self.upgradeCurrentRow)
        tbl.addPopupAction(tbl._actUpgradeRow)

    def addPopupImportNf(self, tbl):
        tbl._actLoadNf = QtGui.QAction(u'Загрузить файл NF', tbl)
        tbl._actLoadNf.setObjectName('actLoadNf')
        tbl.connect(tbl._actLoadNf, QtCore.SIGNAL('triggered()'), self.importNf)
        tbl.addPopupAction(tbl._actLoadNf)

    def addPopupImportNp(self, tbl):
        tbl._actLoadNp = QtGui.QAction(u'Загрузить файл NP', tbl)
        tbl._actLoadNp.setObjectName('actLoadNp')
        tbl.connect(tbl._actLoadNp, QtCore.SIGNAL('triggered()'), self.importNp)
        tbl.addPopupAction(tbl._actLoadNp)

    def addPopupOpenClient(self, tbl):
        tbl._actEditClient = QtGui.QAction(u'Открыть регистрационную карточку', tbl)
        tbl._actEditClient.setObjectName('actEditClient')
        tbl.connect(tbl._actEditClient, QtCore.SIGNAL('triggered()'), self.openClient)
        tbl.addPopupAction(tbl._actEditClient)

    def openClient(self):
        clientDialog = CClientEditDialog(self.tblItems)
        patientRecord = self.db.getRecord(self.db.table('Client'), '*', self.tblItems.currentClientId)
        clientDialog.setRecord(patientRecord)
        clientDialog.show()

    def importNf(self):
        hid = self.tblHeaders.currentItemId()
        helper = CImportHelperNf(hid)
        visualisation = CImportVisualisation(self, helper)
        helper.setSender(visualisation)
        visualisation.exec_()

    def importNp(self):
        hid = self.tblHeaders.currentItemId()
        helper = CImportHelperNp(hid)
        visualisation = CImportVisualisation(self, helper)
        helper.setSender(visualisation)
        visualisation.exec_()

    @pyqtSignature('')
    def on_btnImportAttach_clicked(self):
        helper = CImportHelperNr(None)
        visualisation = CImportVisualisation(self, helper)
        helper.setSender(visualisation)
        visualisation.exec_()
        self.refreshHeadersView()

    def removeCurrentHeaderRow(self):
        db = QtGui.qApp.db
        hid = self.tblHeaders.currentItemId()
        index = self.tblHeaders.currentIndex()

        if index.isValid() and self.tblHeaders.confirmRemoveRow(self.tblHeaders.currentIndex().row()):
            stmts = ["DELETE FROM ExportAttachItem WHERE headerId = %d" % hid,
                     "DELETE FROM ExportAttachHeader WHERE id = %d" % hid]
            for stmt in stmts:
                try:
                    db.query(stmt)
                    db.commit()
                except Exception, e:
                    QtGui.qApp.logCurrentException()
                    db.rollback()
            self.tblHeaders.setCurrentRow(0)
            self.refreshTables()

    def removeSelectedItemRows(self):
        db = QtGui.qApp.db
        ids = self.tblItems.selectedItemIdList()
        index = self.tblItems.currentIndex()

        if self.tblItems.confirmRemoveRow(self.tblItems.currentIndex().row()):
            stmt = "DELETE FROM ExportAttachItem WHERE id IN (%s)" % ','.join(map(str, ids))
            try:
                db.query(stmt)
                db.commit()
            except Exception, e:
                QtGui.qApp.logCurrentException()
                db.rollback()
            self.refreshOnlyItemTable()

    def fillTables(self):
        self._addModels('Header', CHeaderModel(self))
        self._addModels('Item', CItemModel(self))
        self.tblHeaders.setModel(self.modelHeader)
        self.tblHeaders.setSelectionMode(QtGui.QTableView.SingleSelection)
        self.tblItems.setModel(self.modelItem)
        self.tblItems.setSelectionMode(QtGui.QAbstractItemView.ExtendedSelection)
        self.connect(self.tblHeaders.selectionModel(),
                     SIGNAL('selectionChanged(QItemSelection, QItemSelection)'),
                     self.headerRowChanged)
        self.connect(self.tblItems.selectionModel(),
                     SIGNAL('selectionChanged(QItemSelection, QItemSelection)'),
                     self.itemRowChanged)
        self.refreshHeadersView()

    @pyqtSignature('QItemSelection, QItemSelection')
    def headerRowChanged(self, current):
        hid = self.tblHeaders.currentItemId()
        self.refreshItemsView(hid)

    @pyqtSignature('QItemSelection, QItemSelection')
    def itemRowChanged(self, current):
        currentItem = self.tblItems.currentItem()
        self.tblItems.currentClientId = forceInt(currentItem.value('clientId'))

    def refreshTables(self):
        self.refreshHeadersView()
        self.refreshItemsView(self.tblHeaders.currentItemId())

    def refreshOnlyItemTable(self):
        self.refreshItemsView(self.tblHeaders.currentItemId())

#Возвращает список хедеров, удовлетв. условиям фильтра
    def _applyHeaderFilters(self):
        db = QtGui.qApp.db
        table = db.table('ExportAttachHeader')
        cond = []
        #Взять из фильра на форме
        clientId = self.edtAnalysisClientCode.displayText()
        #Точно так же и с остальными полями
        if clientId:
            cond.append(table['clientId'].eq(clientId))
        idList = db.getDistinctIdList(table, idCol='`id`', where=cond)
        return idList

#Возвращает список итемов, удовлетв. условиям фильтра
    def _applyItemFilters(self, headerId):
        db = QtGui.qApp.db
        table = db.table('ExportAttachItem')
        cond = []
        cond.append(table['headerId'].eq(headerId))
        clientId = None
        if clientId:
            cond.append(table['clientId'].eq(clientId))
        idList = db.getDistinctIdList(table, idCol='`id`', where=cond)
        return idList

    def refreshHeadersView(self):
        idList = self._applyHeaderFilters()
        self.modelHeader.setIdList(idList)

    def refreshItemsView(self, headerId=None):
        db = QtGui.qApp.db
        idList = []
        if not headerId:
            pass
        #TODO: remove this check
#            table = db.table('ExportAttachHeader')
#            idListHeader = db.getIdList(table, idCol='id')
#            for headerId in idListHeader:
#                table = db.table('ExportAttachItem')
#                idList.append(db.getIdList(table, where='headerId = %d' % headerId))
        else:
            table = db.table('ExportAttachItem')
            # заменить на applyItemFilter
            idList = self._applyItemFilters(headerId)
            #idList = db.getIdList(table, where='headerId = %d' % headerId)
        self.modelItem.setIdList(idList)

    def loadAttachTypes(self):
        qry = QtGui.qApp.db.query("select id, code, name from rbAttachType")
        while qry.next():
            id = forceInt(qry.record().value(0))
            code = forceString(qry.record().value(1))
            name = forceString(qry.record().value(2))
            chkBox = chkAttachType(id)
            chkBox.setChecked(True)
            chkBox.setText(QtGui.QApplication.translate("MainWindow", "%d. %s" % (id, name), None, QtGui.QApplication.UnicodeUTF8))
            chkBox.setObjectName(_fromUtf8("chk%d" % id))
            self.gridLayout.addWidget(chkBox)
            self.checks.append(chkBox)

    def _checkInvertCalled(self):
        for chk in self.checks:
            if chk.isChecked():
                chk.setCheckState(QtCore.Qt.Unchecked)
            else:
                chk.setCheckState(QtCore.Qt.Checked)

    def _checkAllCalled(self, i=None):
        if i == 2:
            for chk in self.checks:
                chk.setCheckState(QtCore.Qt.Checked)
        elif i == 0:
            for chk in self.checks:
                chk.setCheckState(QtCore.Qt.Unchecked)

    def loadPreferences(self):
        preferences = getPref(QtGui.qApp.preferences.windowPrefs, self.objectName(), {})
        geometry = getPref(preferences, 'geometry', None)
        if type(geometry) == QVariant and geometry.type() == QVariant.ByteArray and not geometry.isNull():
            self.restoreGeometry(geometry.toByteArray())
        state = getPref(preferences, 'state', None)
        if type(state) == QVariant and state.type() == QVariant.ByteArray and not geometry.isNull():
            self.restoreState(state.toByteArray())
        appPreferences = QtGui.qApp.preferences.appPrefs
        #TODO: RLY save

    def savePreferences(self):
        preferences = {}
        setPref(preferences,'geometry',QVariant(self.saveGeometry()))
        setPref(preferences,'state', QVariant(self.saveState()))
        setPref(QtGui.qApp.preferences.windowPrefs, self.objectName(), preferences)
        appPreferences = QtGui.qApp.preferences.appPrefs
        #TODO: RLY save

    def setUserName(self, userName):
        self.setWindowTitle(u'"Экспорт приписного населения - beta')

    def checkConstr(self):
        if not (self.checkConstrain(QtGui.qApp.currentOrgId(), u'В настройках не выбрано текущее ЛПУ')):
            return False
        return True

    def getAttachTypeFilter(self):
        result = []
        for chk in self.checks:
            if chk.isChecked():
                result.append(chk.getId())
        return result

    @pyqtSignature('')
    def on_btnForm_clicked(self):
        if not self.checkConstr:
            return
        if self.formExportData.getReady(self.clnCalcCalendar.selectedDate(), self.getAttachTypeFilter()):
            self.btnForm.setEnabled(False)
            result = self.formExportData.start(u'', self.progressBar)
            (hid, count) = result
            if not count or count == 0:
                self.btnForm.setEnabled(True)
                QtGui.QMessageBox.critical(self, u'Уведомление', u'Сформированный счет не содержит записей.', QtGui.QMessageBox.Close)
            self.refreshHeadersView()
            self.refreshItemsView(hid)
            self.btnForm.setEnabled(True)
        else:
            QtGui.QMessageBox.critical(self, u'Произошла ошибка', u'Выполнить данное действие невозможно.', QtGui.QMessageBox.Close)

    @pyqtSignature('')
    def on_btnExportAttach_clicked(self):
        if not self.checkConstr() or not self.tblHeaders.currentItemId():
            return
        wizard = CExportWizard(self, True, self.tblHeaders.currentItemId())
        wizard.exec_()

    @pyqtSignature('')
    def on_btnRefresh_clicked(self):
        if not self.checkConstr:
            return
        self.refreshTables()

    def updateActionsState(self):
        app = QtGui.qApp
        loggedIn = bool(app.db) and (app.userId is not None)
        # Меню Сессия
        self.actLogin.setEnabled(not loggedIn)
        self.actLogout.setEnabled(loggedIn)
        self.actQuit.setEnabled(True)
        # Меню Настройки
        self.actAppPreferences.setEnabled(loggedIn)
        self.btnExportAttach.setEnabled(loggedIn)
        self.btnForm.setEnabled(loggedIn)
        self.btnImportAttach.setEnabled(loggedIn)
        self.btnRefresh.setEnabled(loggedIn)
        self.chkBoxAll.setEnabled(loggedIn)
        self.chkBoxInvert.setEnabled(loggedIn)
        self.destroyCheckBoxes()

    def destroyCheckBoxes(self):
        for chk in self.checks:
            chk.close()

    @pyqtSignature('')
    def on_actLogin_triggered(self):
        try:
            QtGui.qApp.openDatabase()
            dialog = CLoginDialog(self)
            dialog.setLoginName(QtGui.qApp.preferences.appUserName)
            if dialog.exec_():
                QtGui.qApp.setUserId(dialog.userId(), dialog.demoMode())
                QtGui.qApp.preferences.appUserName = dialog.loginName()
                self.setUserName(QtGui.qApp.preferences.appUserName)
                self.btnExportAttach.setEnabled(True)
                self.setUserName(QtGui.qApp.userName())
                self.updateActionsState()
                self.loadDatabaseData()
            else:
                self.updateActionsState()
            return
        except database.CDatabaseException, e:
            QtGui.QMessageBox.critical(
                self,
                u'Ошибка открытия базы данных',
                unicode(e),
                QtGui.QMessageBox.Close)
        except Exception, e:
            QtGui.QMessageBox.critical(
                self,
                u'Ошибка открытия базы данных',
                u'Невозможно установить соедиенение с базой данных\n' + unicode(e),
                QtGui.QMessageBox.Close)
            QtGui.qApp.logCurrentException()
        QtGui.qApp.closeDatabase()


    @pyqtSignature('')
    def on_actLogout_triggered(self):
        QtGui.qApp.setUserId(None, False)
        QtGui.qApp.closeDatabase()
        self.updateActionsState()
        self.setUserName('')


    @pyqtSignature('')
    def on_actQuit_triggered(self):
        self.close()
        #TODO:
#        fileName = QtGui.QFileDialog.getOpenFileName(
#            self, u'Укажите файл с данными', '', u'Файлы XML (*.xml)')
#        if fileName != '':
#            nf = CNfReader(self, fileName, self.progressBar)
#            h = nf.readNfHeader()
#            b = nf.readNextNfBlock()

    @QtCore.pyqtSignature('')
    def on_actConnection_triggered(self):
        dlg = CConnectionDialog(self)
        preferences = QtGui.qApp.preferences
        dlg.setDriverName(preferences.dbDriverName)
        dlg.setServerName(preferences.dbServerName)
        dlg.setServerPort(preferences.dbServerPort)
        dlg.setDatabaseName(preferences.dbDatabaseName)
        dlg.setUserName(preferences.dbUserName)
        dlg.setPassword(preferences.dbPassword)
        if dlg.exec_():
            preferences.dbDriverName = dlg.driverName()
            preferences.dbServerName = dlg.serverName()
            preferences.dbServerPort = dlg.serverPort()
            preferences.dbDatabaseName = dlg.databaseName()
            preferences.dbUserName = dlg.userName()
            preferences.dbPassword = dlg.password()
            preferences.save()


    @QtCore.pyqtSignature('')
    def on_actDecor_triggered(self):
        dlg = CDecorDialog(self)
        preferences = QtGui.qApp.preferences
        dlg.setStyle(preferences.decorStyle)
        dlg.setStandardPalette(preferences.decorStandardPalette)
        dlg.setMaximizeMainWindow(preferences.decorMaximizeMainWindow)
        dlg.setFullScreenMainWindow(preferences.decorFullScreenMainWindow)
        if dlg.exec_():
            preferences.decorStyle = dlg.style()
            preferences.decorStandardPalette = dlg.standardPalette()
            preferences.decorMaximizeMainWindow = dlg.maximizeMainWindow()
            preferences.decorFullScreenMainWindow = dlg.fullScreenMainWindow()
            preferences.save()
            QtGui.qApp.applyDecorPreferences()


    @QtCore.pyqtSignature('')
    def on_actAppPreferences_triggered(self):
        qApp = QtGui.qApp
        dialog = CAppPreferencesDialog(self)
        dialog.setTabGlobalEnabled(qApp.userHasAnyRight([urAdmin,
                                                         urAccessSetupGlobalPreferencesWatching,
                                                         urAccessSetupGlobalPreferencesEdit]))
        dialog.setProps(qApp.preferences.appPrefs)
        if dialog.exec_():
            prevOrgId = qApp.currentOrgId()
            qApp.preferences.appPrefs.update(dialog.props())
            qApp.preferences.save()
            orgId = qApp.currentOrgId()
            self.setUserName(qApp.userName())


    @QtCore.pyqtSignature('')
    def on_actAboutQt_triggered(self):
        QtGui.QMessageBox.aboutQt(self, u'О Qt')
