--
-- Импорт СМО для Смоленска
--  данные выбраны из "Приложение 4 Справочник ЛПУ области.xls" в текстовый файл
--

CREATE TEMPORARY TABLE `LPU` (
`NUM` VARCHAR(2),
`CODE` VARCHAR(7),
`NAME` VARCHAR(80),
`OGRN` VARCHAR(80)
) ENGINE = InnoDB DEFAULT CHARSET=utf8 COMMENT = 'Справочник ЛПУ';

CREATE TEMPORARY TABLE `infisList` (
`infisCode` VARCHAR(10)
) ENGINE = InnoDB DEFAULT CHARSET=utf8 COMMENT = 'Список инфис кодов организаций, которые уже есть в БД';

LOAD DATA LOCAL INFILE 'Приложение 4 Справочник ЛПУ области.txt'
    INTO TABLE `LPU`
    CHARACTER SET cp1251
    FIELDS TERMINATED BY '\t' OPTIONALLY ENCLOSED BY '"'
    LINES TERMINATED BY '\r\n'
    IGNORE 6 LINES;

-- Составляем список инфис кодов организаций, которые уже есть в БД
INSERT INTO `infisList`
    SELECT `infisCode`
      FROM `Organisation`, `LPU` 
      WHERE `Organisation`.`infisCode` = `LPU`.`CODE`;

-- Добавляем новые записи
INSERT INTO `Organisation` (fullName, shortName, title, infisCode, OGRN)
    SELECT `NAME` AS `fullName`, 
           `NAME` AS `shortName`, 
           `NAME` AS `title`, 
           `CODE` AS `infisCode`, 
           `OGRN`
      FROM `LPU`
      WHERE `LPU`.`CODE` NOT IN (SELECT `infisCode` FROM `infisList`);

-- Обновляем записи, которые уже есть в БД
UPDATE `Organisation`, `LPU`
  SET `fullName` = `LPU`.`NAME`,
      `shortName` = `LPU`.`NAME`,
      `title` = `LPU`.`NAME`,
      `Organisation`.`OGRN` = `LPU`.`OGRN`
  WHERE `Organisation`.`infisCode` = `LPU`.`CODE` 
    AND `LPU`.`CODE` IN (SELECT `infisCode` FROM `infisList`);
