--
-- Импорт СМО для Смоленска
--  данные выбраны из "Приложение 12 Справочник категорий льготности.xls" в текстовый файл
--

CREATE TEMPORARY TABLE `S` (
`CODE` VARCHAR(7),
`NAME` VARCHAR(80)
) ENGINE = InnoDB DEFAULT CHARSET=utf8 COMMENT = 'Справочник кодов льгот';

CREATE TEMPORARY TABLE `infisList` (
`infisCode` VARCHAR(10)
) ENGINE = InnoDB DEFAULT CHARSET=utf8 COMMENT = 'Список инфис кодов, которые уже есть в БД';

LOAD DATA LOCAL INFILE 'Приложение 12 Справочник категорий льготности.txt'
    INTO TABLE `S`
    CHARACTER SET cp1251
    FIELDS TERMINATED BY '\t' OPTIONALLY ENCLOSED BY '"'
    LINES TERMINATED BY '\r\n'
    IGNORE 6 LINES;

-- Проверяем наличие класса соц. статуса с кодом 1, если нет - добавляем
SET @socClassId = NULL;
SELECT @socClassId := `id` FROM `rbSocStatusClass` WHERE `code` = '1' AND `name` = 'льгота';
SET @s1 = IF(@socClassId, "SELECT @socClassId", "INSERT INTO `rbSocStatusClass`(`code`, `name`) VALUES ('1','льгота');");
PREPARE stmt FROM @s1;
EXECUTE stmt;
SELECT @socClassId := `id` FROM `rbSocStatusClass` WHERE `code` = '1' AND `name` = 'льгота';


-- Составляем список инфис кодов, которые уже есть в БД
INSERT INTO `infisList`
    SELECT `S`.`CODE`
      FROM `rbSocStatusType`, `S` 
      WHERE `rbSocStatusType`.`name` = `S`.`NAME`;

-- Добавляем новые записи
INSERT INTO `rbSocStatusType` (code, name, regionalCode)
    SELECT `CODE` AS `code`, 
           `NAME` AS `name`,
           `CODE` AS `regionalCode`
      FROM `S`
      WHERE `S`.`CODE` NOT IN (SELECT `infisCode` FROM `infisList`);

INSERT INTO `rbSocStatusClassTypeAssoc` (`class_id`, `type_id`)
    SELECT @socClassId AS `class_id`,
           `rbSocStatusType`.`id` AS `type_id`
      FROM `rbSocStatusType`, `S`
      WHERE `rbSocStatusType`.`name` = `S`.`NAME` 
        AND `S`.`CODE` NOT IN (SELECT `infisCode` FROM `infisList`);

-- Обновляем записи, которые уже есть в БД
UPDATE `rbSocStatusType`, `S`
  SET `rbSocStatusType`.`regionalCode` = `S`.`CODE`,
      `rbSocStatusType`.`code` = `S`.`CODE`
  WHERE `rbSocStatusType`.`name` = `S`.`NAME` 
    AND `S`.`CODE` IN (SELECT `infisCode` FROM `infisList`);
