#!/usr/bin/env python
# -*- coding: utf-8 -*-

#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

from PyQt4 import QtGui, QtCore

from Ui_exportSettings import Ui_Dialog

class CExportSettingsDialog(QtGui.QDialog, Ui_Dialog):
    
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)
        self.savePath = ''
        self.setWindowTitle(u'Настройки экспортирования')
        
    @QtCore.pyqtSignature('')
    def on_btnOpenSaveDirPath_clicked(self):
        filter = QtCore.QString('')
        file = QtGui.QFileDialog.getExistingDirectory(self,
                                           u'Выбирете путь для сохранения',
                                           self.savePath)
                                           
        if file:
            self.edtSaveDirPath.setText(file)
            self.savePath = file
            
            
    def setSavePath(self, path):
        self.savePath = path
        self.edtSaveDirPath.setText(path)
    
    def getSavePath(self):
        return self.savePath