# -*- coding: utf-8 -*-

#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################


"""
editor of app preferences
"""

from PyQt4 import QtCore, QtGui
from Orgs.Orgs      import selectOrganisation
from Ui_Preferences import Ui_Dialog


class CPreferencesDialog(QtGui.QDialog, Ui_Dialog):

    def __init__(self, parent):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)

    def setOrgId(self, val):
        self.cmbOrganisation.setValue(val)


    def orgId(self):
        return self.cmbOrganisation.value()


    def setOrgStructureId(self, val):
        self.cmbOrgStructure.setValue(val)


    def orgStructureId(self):
        return self.cmbOrgStructure.value()


    def setOnlyWithHistory(self, val):
        self.chkOnlyWithHistory.setChecked(val)


    def onlyWithHistory(self):
        return self.chkOnlyWithHistory.isChecked()


    def setDoctorCodeSource(self, val):
        self.cmbDoctorCodeSource.setCurrentIndex(val)


    def doctorCodeSource(self):
        return self.cmbDoctorCodeSource.currentIndex()



    @QtCore.pyqtSignature('int')
    def on_cmbOrganisation_currentIndexChanged(self, index):
        orgId = self.cmbOrganisation.value()
        QtGui.qApp._orgId = orgId
        self.cmbOrgStructure.setOrgId(orgId)


    @QtCore.pyqtSignature('')
    def on_btnSelectOrganisation_clicked(self):
        orgId = selectOrganisation(self, self.cmbOrganisation.value(), False)
        self.cmbOrganisation.updateModel()
        if orgId:
            self.cmbOrganisation.setValue(orgId)


