#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import re
from sys import *
import codecs
from os.path import *
from optparse import OptionParser

from s11main import CS11mainApp
from Users.DirtyCrypt import decryptPassword

#from library.DialogBase  import CDialogBase
from library.database    import *
from library.Utils       import *
from Exchange.Utils      import logMessage
from Exchange.Cimport    import Cimport, CEISimport

from PyQt4 import QtCore, QtGui, QtSql
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtSql import *
from Ui_importKladrEis import Ui_MainWindow

import create_sql
import import_sql


class mainWin(CEISimport, QtGui.QMainWindow, Ui_MainWindow):
    def __init__(self):
        QMainWindow.__init__(self)
        self.setupUi(self)
        Cimport.__init__(self, additionalInit = False)
        self.checkName()
        #TODO: уточнить logCurrentException
        QtGui.qApp.logCurrentException = lambda: self.log.append("Error!") 
        
        pref=QtGui.qApp.preferences
        props=pref.appPrefs
        self.edtIP.setText(forceStringEx(props.get('EIS_serverName', '')))
        self.edtFileName.setText(forceStringEx(props.get('EIS_databaseName', '')))
        self.edtEisUser.setText(forceStringEx(props.get('EIS_userName', '')))
        self.edtEisPassword.setText(forceStringEx(props.get('EIS_password', '')))
        
        self.edtKladrServer.setText(pref.dbServerName)
        self.edtKladrUser.setText(pref.dbUserName)
        self.edtKladrPassword.setText(pref.dbPassword)

     
    def openKLADR(self):
        Kladr_dbDriverName = "MYSQL"
        Kladr_dbServerName = forceStringEx(self.edtKladrServer.text())
        Kladr_dbServerPort = 3306
        Kladr_dbDatabaseName = 'kladr'
        Kladr_dbUserName = forceStringEx(self.edtKladrUser.text())
        Kladr_dbPassword = forceStringEx(self.edtKladrPassword.text())
        
        self.log.append(u'Открытие БД kladr...')
        QtGui.qApp.processEvents()
        if QtGui.qApp.db:
            QtGui.qApp.db.close()
        try:
            QtGui.qApp.db = connectDataBase(Kladr_dbDriverName, Kladr_dbServerName, Kladr_dbServerPort, Kladr_dbDatabaseName, Kladr_dbUserName, Kladr_dbPassword, 'samson')
        except Exception, e:
            QtGui.QMessageBox.critical( None, 
                                    u'Ошибка!',
                                    u'Не могу открыть базу данных %s!\nОшибка: %s\nВы уверены, что правильно ввели сервер, имя пользователя и пароль?'%(Kladr_dbDatabaseName, str(e)))
            return False
        
        query = QtGui.qApp.db.query( 'show columns from kladr.STREET' )
        while query.next():
            record = query.record()
            fieldName = forceString(record.value(0))
            if fieldName == 'eisPrefix':
                return True 
        if QtGui.QMessageBox.question( self,
                                       u'Внимание!',
                                       u'Поле eisPrefix отсутствует. Добавить?',
                                       QtGui.QMessageBox.Yes|QtGui.QMessageBox.No,
                                       QtGui.QMessageBox.Yes) == QtGui.QMessageBox.Yes:
            query = QtGui.qApp.db.query( 'ALTER TABLE `kladr`.`STREET` ADD COLUMN `eisPrefix` INT(11) NULL DEFAULT NULL' )
            if query:
                return True
        return False
            
     
     
    def openEis(self):
      #TODO: перенести часть функции в CEisImport  
        EIS_dbDriverName = "FireBird"
        EIS_dbServerName = forceStringEx(self.edtIP.text())
        EIS_dbServerPort = 0
        EIS_dbDatabaseName = forceStringEx(self.edtFileName.text())
        EIS_dbUserName = forceStringEx(self.edtEisUser.text())
        EIS_dbPassword = forceStringEx(self.edtEisPassword.text())

        self.log.append(u'Открытие БД %s...'%EIS_dbDatabaseName)
        QtGui.qApp.processEvents()
        if QtGui.qApp.EIS_db:
            QtGui.qApp.EIS_db.close()
        try:
            QtGui.qApp.EIS_db = connectDataBase(EIS_dbDriverName, EIS_dbServerName, EIS_dbServerPort, EIS_dbDatabaseName, EIS_dbUserName, EIS_dbPassword, 'eisbase')
        except Exception, e:
            QtGui.QMessageBox.critical( None, 
                                    u'Ошибка!',
                                    u'Не могу открыть базу данных %s!\nОшибка: %s\nВы уверены, что правильно ввели имя базы данных?'%(EIS_dbDatabaseName, e))
            return False
        return True

# а вот так делается проверка соединения!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!   
#            TARIFF_MONTH=EIS_db.getRecordEx('TARIFF_MONTH', '*', '')
#            ID_TARIFF_MONTH=forceString(TARIFF_MONTH.value('ID_TARIFF_MONTH'))
#            TARIFF_MONTH_BEG=forceString(TARIFF_MONTH.value('TARIFF_MONTH_BEG').toDate())
#            TARIFF_MONTH_END=forceString(TARIFF_MONTH.value('TARIFF_MONTH_END').toDate())
#            MU_IDENT = EIS_db.getRecordEx('MU_IDENT', 'ID_LPU')
#            ID_LPU = forceInt(MU_IDENT.value('ID_LPU')) if MU_IDENT else None
#            message=u'Соединение успешно!\nтарифный месяц: %s (%s-%s)\nИдентификатор ЛПУ в ЕИС ОМС: %s' % (ID_TARIFF_MONTH, TARIFF_MONTH_BEG, TARIFF_MONTH_END, ID_LPU)
     
             
    def runProgramScript(self,  name,  dic,  title):
        error = self.runScript(name.COMMAND.split('\n'), dic) 
        if error is not None:
            QtGui.QMessageBox.warning(self, u'Ошибка при выполнении запроса к БД',
                        u'Ошибка при выполнении операции "%s".\n%s.'%(title, error.text()))
            self.log.append(unicode(error.text()))
            return False
        QtGui.qApp.processEvents()
        return True
    
    def loadFromEIS(self, msg, table):
        self.progressBar.setValue(0)
        result = QtGui.qApp.EIS_db.query(msg)
        records = []
        while result.next():
            records.append(result.record())
        max = len(records)
        for i, record in enumerate(records):
            QtGui.qApp.db.insertRecord(table, record)
            self.progressBar.setValue((i*100)/max)
        if result.lastError().isValid():
            raise CDatabaseException(CDatabase.errQueryError%result.lastError().text()) 
            return False
        return result


    def loadKLADRFromEis(self):
        self.log.append(u'Загрузка таблицы eisHouse...')
        QtGui.qApp.processEvents()
        result = self.loadFromEIS(create_sql.houseStmt, "eisHouse")
        self.log.append(u'Загрузка таблицы tmpTOWN...')
        QtGui.qApp.processEvents()
        result = result and self.loadFromEIS(create_sql.townStmt, "tmpTOWN")
        self.log.append(u'Загрузка таблицы tmpGEONIMNAME...')
        QtGui.qApp.processEvents()
        result = result and self.loadFromEIS(create_sql.geonimNameStmt, "tmpGEONIMNAME")
        self.log.append(u'Загрузка таблицы tmpGEONIMTYPE...')
        QtGui.qApp.processEvents()
        result = result and self.loadFromEIS(create_sql.geonimTypeStmt, "tmpGEONIMTYPE")
        self.log.append(u'Загрузка таблицы tmpTOPONIM...')
        QtGui.qApp.processEvents()
        result = result and self.loadFromEIS(create_sql.toponimStmt, "tmpTOPONIM")
        self.log.append(u'Загрузка таблицы tmpPREFIX...')
        QtGui.qApp.processEvents()
        result = result and self.loadFromEIS(create_sql.prefixStmt, "tmpPREFIX")
        QtGui.qApp.processEvents()
#        result = self.loadFromEIS(msg2) or result
        if result:
            self.log.append(u'Загрузка таблиц завершена.')
            QtGui.qApp.processEvents()
            return True
        else:
            self.log.append(u'Ошибка при загрузке из таблицы EIS.HOUSE')
            return False
            
    def syncKLADRWithEis(self):
        self.log.append(u'Формирование соответствий между вспомогательными таблицами ЕИС и КЛАДР.')
        db = QtGui.qApp.db
        tableKLADR = db.table('KLADR')
        tableTOWN = db.table('tmpTOWN')
        tableTownLink = db.table('tmpTownLink')
        tablePREFIX = db.table('tmpPREFIX')
        tableGEOTYPE = db.table('tmpGEONIMTYPE')
        tableGEONAME = db.table('tmpGEONIMNAME')
        tableTOPONIM = db.table('tmpTOPONIM')
        tableSOCR = db.table('SOCRBASE')
        tableSTREET = db.table('STREET')
        townRecords = db.getRecordList(tableKLADR, '*', [tableKLADR['CODE'].like('78%'), tableKLADR['SOCR'].inlist([u'п', u'г', u'д'])])
        for town in townRecords:
            name = forceString(town.value('NAME'))
            name = re.sub(r'\(.*\)', "", name)
            name = name.strip()
            record = db.getRecordEx(tableTOWN, '*', tableTOWN['TOWN_NAME'].like(u'%%%s%%'%name))
            if record:
                code = forceString(town.value('CODE'))
                townId = forceInt(record.value('ID_TOWN'))
                linkRecord = tableTownLink.newRecord()
                linkRecord.setValue('ID_TOWN', townId)
                linkRecord.setValue('CODE', code)
                db.insertRecord(tableTownLink, linkRecord)
                
        geoTRecords = db.getRecordList(tableGEOTYPE, '*', [])
        for record in geoTRecords:
            name = forceString(record.value('TYPE_FULL_NAME'))
            socrRecord = db.getRecordEx(tableSOCR, '*', tableSOCR['SOCRNAME'].like(name))
            if socrRecord:
                record.setValue('CODE', forceString(socrRecord.value('SCNAME')))
                db.updateRecord(tableGEOTYPE, record)
                
        
        
        streetRecordList = db.getRecordList(tableSTREET, '*', tableSTREET['CODE'].like('78...00'))
        fullLen = len(streetRecordList)
        self.log.append(u'Загрузка улиц. Всего %s'%fullLen)
        self.progressBar.setValue(0)
        for i, streetRecord in enumerate(streetRecordList):
            townCode = forceString(streetRecord.value('CODE'))[0:11]
            townId = forceInt(db.translate(tableTownLink, 'CODE',  townCode, 'ID_TOWN'))
            name = forceString(streetRecord.value('NAME'))
            code = forceString(streetRecord.value('CODE'))
            socr = forceString(streetRecord.value('SOCR'))
            m = re.search(r'\((.*)\)', name)
            toponim = m.group(1) if m else None
            name = re.sub(r'\(.*\)', "", name)
            name = name.strip()
            nameId = forceInt(db.translate(tableGEONAME, 'GEONIM_NAME', name, 'ID_GEONIM_NAME'))
            if not nameId:
                name = name.split()
                if len(name) == 2:
                    nameId = forceInt(db.translate(tableGEONAME, 'GEONIM_NAME', '%s %s'%(name[1], name[0]), 'ID_GEONIM_NAME'))
                    if not nameId:
                        name[1] = name[1].replace(u'Б.',  u'Б')
                        name[1] = name[1].replace(u'М.',  u'М')
                        nameRecord = db.getRecordEx(tableGEONAME, '*', tableGEONAME['GEONIM_NAME'].like('%s...%s'%(name[1], name[0])))
                        if nameRecord:
                            nameId = forceInt(nameRecord.value('ID_GEONIM_NAME'))
            toponimId = None
            if toponim:
                toponimId = db.translate(tableTOPONIM, 'TOPONIM_NAME', toponim, 'ID_TOPONIM')
            if townId and nameId:
                cond = [tablePREFIX['ID_TOWN'].eq(townId), tablePREFIX['ID_GEONIM_NAME'].eq(nameId)]
                if toponimId:
                    cond.append(tablePREFIX['ID_TOPONIM'].eq(toponimId))
                geotypeId = forceInt(db.translate(tableGEOTYPE, 'CODE', socr, 'ID_GEONIM_TYPE'))
                if geotypeId:
                    cond.append(tablePREFIX['ID_GEONIM_TYPE'].eq(geotypeId))
                record = db.getRecordEx(tablePREFIX, 'ID_PREFIX', cond)
                if record:
                    prefix = forceInt(record.value('ID_PREFIX'))
                    streetRecord.setValue('eisPrefix', prefix)
                    stmt = """update kladr.STREET set eisPrefix=%i where kladr.STREET.CODE like '%s%%'"""""%(prefix, str(code[:-2]))
                    db.query(stmt)
            self.progressBar.setValue(i*100/fullLen)
            QtGui.qApp.processEvents()
        return True
             
    def fixResult(self, result):
        if result:
            self.log.append(u'Обновление выполнено!')
            QtGui.qApp.processEvents()
            QtGui.QMessageBox.information( None, 
                                    u'Всё хорошо!',
                                    u'Обновление выполнено.')
        else:
            QtGui.QMessageBox.information( None, 
                                    u'Всё плохо!',
                                    u'Обновление не выполнено.')
                                    
    
    def startImport(self):
        self.checkName()
        if not self.openKLADR():
            self.log.append(u'Обнаружены проблемы с открытием базы КЛАДР')
            return
        if not self.openEis():
            self.log.append(u'Обнаружены проблемы с открытием базы ЕИС')
            return
        QtGui.qApp.db.transaction()
        result = self.runProgramScript(create_sql, {}, u'Cкрипт подготовки таблиц')
        result = result and self.loadKLADRFromEis()
        result = result and self.syncKLADRWithEis()
        if result:
            self.log.append(u'Обновление КЛАДР завершено!')
            QtGui.qApp.db.commit()
        else:
            QtGui.qApp.db.rollback()
        return result

                        
             
 
if __name__ == "__main__":
    parser = OptionParser(usage = "usage: %prog [options]",add_help_option=True)
    parser.add_option("-s", "--server",   dest="server",   help="server, default '%default'",              default="localhost", metavar="SERVER")
    parser.add_option("-d", "--database", dest="database", help="database, default '%default'",            default="s11",     metavar="DATABASE")
    parser.add_option("-u", "--user",     dest="user",     help="mysql user, default '%default'",          default="root",      metavar="USER")
    parser.add_option("-p", "--password", dest="password", help="mysql user password, default '%default'", default="",          metavar="PASSWORD")
    (options, args) = parser.parse_args()
    #app = QtGui.QApplication(sys.argv)
    app = CS11mainApp(sys.argv, None, None, None, None)
    stdTtranslator = QtCore.QTranslator()
    stdTtranslator.load(os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), 'i18n', 'std_ru.qm'))
    app.installTranslator(stdTtranslator)
    #Перевод стандартных диалогов Qt
    stdTtranslatorLib = QtCore.QTranslator()
    stdTtranslatorLib.load(os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), 'i18n', 'qt_ru_lib.qm'))
    app.installTranslator(stdTtranslatorLib)
    QtGui.qApp = app
    try:
        mw=mainWin()
        mw.show()
        app.exec_()
    except Exception, e:
        QtGui.QMessageBox.critical( None, 
                                    'error',
                                    unicode(e),
                                    QtGui.QMessageBox.Close)
    mw = None
    app = None
