#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from sys import *
from os.path import *

from s11main import CS11mainApp

#from library.DialogBase  import CDialogBase
from library.database    import *
from library.Utils       import *
from Exchange.Cimport    import Cimport, CEISimport

from PyQt4 import QtCore, QtGui, QtSql
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtSql import *
from Ui_main import Ui_MainWindow


class mainWin(QtGui.QMainWindow, Ui_MainWindow):
    def __init__(self):
        QMainWindow.__init__(self)
        self.setupUi(self)
        #TODO: уточнить logCurrentException
        #QtGui.qApp.logCurrentException = lambda: self.lblStatus.setText('Error!')
        self.lblStatus.setText('')
        
        pref=QtGui.qApp.preferences
        props=pref.appPrefs
        self.eisAddress = forceStringEx(props.get('EIS_serverName', ''))
        self.eisDB = forceStringEx(props.get('EIS_databaseName', ''))
        self.eisUser = forceStringEx(props.get('EIS_userName', ''))
        self.eisPasswd = forceStringEx(props.get('EIS_password', ''))
        
        self.address = pref.dbServerName
        self.user = pref.dbUserName
        self.passwd = pref.dbPassword
        
        QtCore.QObject.connect(self.streetNameStart,QtCore.SIGNAL("textChanged(QString)"),self.set_ns1)
        QtCore.QObject.connect(self.streetNameStart_2,QtCore.SIGNAL("textChanged(QString)"),self.set_ns1)
        QtCore.QObject.connect(self.infis_check,QtCore.SIGNAL("stateChanged(int)"),self.set_ns)
        QtCore.QObject.connect(self.fillButton,QtCore.SIGNAL("clicked()"),self.matchRows)

     
    def openKLADR(self):
        Kladr_dbDriverName = "MYSQL"
        Kladr_dbServerName = self.address
        Kladr_dbServerPort = 3306
        Kladr_dbDatabaseName = 'kladr'
        Kladr_dbUserName = self.user
        Kladr_dbPassword = self.passwd
        
        self.lblStatus.setText(u'Открываю базу KLADR (%s)'%self.address)
        
        QtGui.qApp.processEvents()
        if QtGui.qApp.db:
            QtGui.qApp.db.close()
        try:
            QtGui.qApp.db = connectDataBase(Kladr_dbDriverName, Kladr_dbServerName, Kladr_dbServerPort, Kladr_dbDatabaseName, Kladr_dbUserName, Kladr_dbPassword, 'samson')
        except Exception, e:
            QtGui.QMessageBox.critical( None, 
                                    u'Ошибка!',
                                    u'Не могу открыть базу данных %s!\nОшибка: %s\nВы уверены, что правильно ввели сервер, имя пользователя и пароль?'%(Kladr_dbDatabaseName, str(e)))
            return False
        
        query = QtGui.qApp.db.query( 'show columns from kladr.STREET' )
        while query.next():
            record = query.record()
            fieldName = forceString(record.value(0))
            if fieldName == 'eisPrefix':
                return True 
        if QtGui.QMessageBox.question( self,
                                       u'Внимание!',
                                       u'Поле eisPrefix отсутствует. Добавить?',
                                       QtGui.QMessageBox.Yes|QtGui.QMessageBox.No,
                                       QtGui.QMessageBox.Yes) == QtGui.QMessageBox.Yes:
            query = QtGui.qApp.db.query( 'ALTER TABLE `kladr`.`STREET` ADD COLUMN `eisPrefix` INT(11) NULL DEFAULT NULL' )
            if query:
                return True
        return False
            
     
     
    def openEIS(self):
      #TODO: перенести часть функции в CEisImport  
        EIS_dbDriverName = "FireBird"
        EIS_dbServerName = self.eisAddress
        EIS_dbServerPort = 0
        EIS_dbDatabaseName = self.eisDB
        EIS_dbUserName = self.eisUser
        EIS_dbPassword = self.eisPasswd
        
        self.lblStatus.setText(u'Открываю базу EIS (%s)'%self.eisAddress)

        QtGui.qApp.processEvents()
        if QtGui.qApp.EIS_db:
            QtGui.qApp.EIS_db.close()
        try:
            QtGui.qApp.EIS_db = connectDataBase(EIS_dbDriverName, EIS_dbServerName, EIS_dbServerPort, EIS_dbDatabaseName, EIS_dbUserName, EIS_dbPassword, 'eisbase')
        except Exception, e:
            QtGui.QMessageBox.critical( None, 
                                    u'Ошибка!',
                                    u'Не могу открыть базу данных %s!\nОшибка: %s\nВы уверены, что правильно ввели имя базы данных?'%(EIS_dbDatabaseName, e))
            return False
        return True

    def start(self):
        if self.openKLADR() and self.openEIS():
            self.kladrModel=kladrTableModel(self)
            self.kladrView.setModel(self.kladrModel)
            self.eisModel=eisTableModel(self)
            self.eisView.setModel(self.eisModel)
            self.lblStatus.setText(u'Подключен к базе КЛАДР (%s) и EIS (%s)'%(self.address, self.eisAddress))
            
    def set_ns1(self, text):
        self.set_ns()
    
    def set_ns(self):
        ns=self.streetNameStart.text()
        self.kladrModel.setNameStart(ns)
#        self.infisModel.setNameStart('' if self.infis_check.checkState() else ns)
        inf=self.infis_check.checkState()
        inf_ns=self.streetNameStart_2.text() if inf else ns
        self.eisModel.setNameStart(inf_ns)
        self.label_4.setEnabled(inf)
        self.streetNameStart_2.setEnabled(inf)
        
    def matchRows(self):
        kladrSel=self.kladrView.selectionModel()
        kladrRows=kladrSel.selectedRows()
        eisSel=self.eisView.selectionModel()
        eisRows=eisSel.selectedRows()
        if eisRows!=[]:
            eisRow=eisRows[0]
            for kladrRow in kladrRows:
                self.setPrefix(kladrRow, eisRow)
            self.kladrModel.setQuery(self.kladrModel.query, QtGui.qApp.db.db)
            self.eisModel.setQuery(self.eisModel.query, QtGui.qApp.EIS_db.db)
            
    def setPrefix(self, kladrRow, eisRow):
        k_row=kladrRow.row()
        km=self.kladrModel
        k_code=forceString(km.data(km.index(k_row, 2)).toString())
        eisPrefix = forceInt(eisRow.data())
        
        stmt='''update STREET set eisPrefix=%i 
                where CODE="%s"
                        '''%(eisPrefix, k_code)
        query = QtGui.qApp.db.query(stmt)
        if not query.lastError().isValid():
            self.lblStatus.setText(u'Записано')

class kladrTableModel(QSqlQueryModel):
    def __init__(self, parent):
        QSqlQueryModel.__init__(self, parent)
        self.query=''
        self.setNameStart('')

    def setNameStart(self, ns):
        q1 = u'select NAME, SOCR, CODE, `INDEX` from STREET'
        q2=u' where eisPrefix is NULL and CODE like \'78%00\''
        q3=u' order by NAME'
        if(ns!=''):
            q2+=u' and NAME like \"' + ns + '%\"'
        self.query=q1+q2+q3
        self.setQuery(self.query, QtGui.qApp.db.db)
        
        
class eisTableModel(QSqlQueryModel):
    def __init__(self, parent):
        QSqlQueryModel.__init__(self, parent)
        self.dlg = parent
        self.query=''
        self.setNameStart('')

    def setNameStart(self, ns):
        cond = ''
        if(ns!=''):
            cond = u'and (geonim_name.geonim_name containing \'%s\')'%ns
        stmt = u'''select 
            prefix.id_prefix as EISPREFIX,
            geonim_name.geonim_name as StreetName,
            t_geonim.geonim_type_name as StreetType,
            town.town_name as TownName,
            toponim.toponim_name as TownArea
        from geonim_name
           inner join prefix on (geonim_name.id_geonim_name = prefix.id_geonim_name)
           inner join t_geonim on (prefix.id_geonim_type = t_geonim.id_geonim_type)
           inner join town on (prefix.id_town = town.id_town)
           inner join toponim on (prefix.id_toponim = toponim.id_toponim)
        where 
           (
              (prefix.is_active = 1)
                %s
           )'''%cond
        self.query=stmt
        self.setQuery(self.query, QtGui.qApp.EIS_db.db)
        err =  self.lastError()
        if err:
            self.dlg.lblStatus.setText(err.text())

if __name__ == "__main__":
    app = CS11mainApp(sys.argv, None, None, None, None)
    stdTtranslator = QtCore.QTranslator()
    stdTtranslator.load(os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), 'i18n', 'std_ru.qm'))
    app.installTranslator(stdTtranslator)
    #Перевод стандартных диалогов Qt
    stdTtranslatorLib = QtCore.QTranslator()
    stdTtranslatorLib.load(os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), 'i18n', 'qt_ru_lib.qm'))
    app.installTranslator(stdTtranslatorLib)
    QtGui.qApp = app
    try:
        mw=mainWin()
        mw.show()
        mw.start()
        app.exec_()
    except Exception, e:
        QtGui.QMessageBox.critical( None, 
                                    'error',
                                    unicode(e),
                                    QtGui.QMessageBox.Close)
    mw = None
    app = None
