# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################

import hashlib

__all__ = [ 'calcCheckSum',
          ]

def calcCheckSum(fileName):
    checksum = hashlib.md5()
    file = open(fileName, 'rb')
    try:
        while True:
            block = file.read(65536)
            if not block:
                break
            checksum.update(block)
    finally:
        file.close()
    return checksum.hexdigest()
