# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################


from PyQt4 import QtGui

from library.blmodel.Model import CModelMetaType


class CRelationship(object):
    def __init__(self, bl_model_class, fieldNameId):
        if isinstance(bl_model_class, basestring):
            bl_model_class = CModelMetaType.register.getClassByName(bl_model_class)
            assert bl_model_class

        self._bl_model_class = bl_model_class
        self._fieldNameId = fieldNameId

    def __get__(self, instance, owner):
        if not instance:
            return self

        if self._fieldNameId in instance._relationShips.keys():
            return instance._relationShips[self._fieldNameId]

        idValue = getattr(instance, self._fieldNameId)
        if not idValue:
            return None

        record = QtGui.qApp.db.getRecord(self._bl_model_class.tableName, '*', idValue)
        model = self._bl_model_class(record) if record else None
        instance._relationShips[self._fieldNameId] = model
        return model

    def __set__(self, instance, value):
        assert isinstance(value, self._bl_model_class)

        instance._relationShips[self._fieldNameId] = value
        setattr(instance, self._fieldNameId, value.id if value else None)
