# -*- coding: utf-8 -*-
#############################################################################
##
## Copyright (C) 2006-2012 Chuk&Gek and Vista Software. All rights reserved.
## Copyright (C) 2012-2017 SAMSON Group. All rights reserved.
##
#############################################################################
##
## Это программа является свободным программным обеспечением.
## Вы можете использовать, распространять и/или модифицировать её согласно
## условиям GNU GPL версии 3 или любой более поздней версии.
##
#############################################################################


"""
editor of preferences of application output
"""
from PyQt4 import QtGui
from PyQt4.QtCore import Qt

from Ui_decor import Ui_decorDialog

class CDecorDialog(QtGui.QDialog, Ui_decorDialog):
    def __init__(self, parent):
        QtGui.QDialog.__init__(self, parent)
        self.setupUi(self)
        self.cmbStyle.insertItems(0, QtGui.QStyleFactory.keys())
        self.cmbFont.setWritingSystem(QtGui.QFontDatabase.Cyrillic)


    def setStyle(self, style):
        index = self.cmbStyle.findText(style, Qt.MatchFixedString)
        if index < 0:
            index = 0
        self.cmbStyle.setCurrentIndex(index)


    def setStandardPalette(self, standardPalette):
        self.chkStandartPalette.setChecked(standardPalette)


    def setMaximizeMainWindow(self, maximizeMainWindow):
        self.chkMaximizeMainWindow.setChecked(maximizeMainWindow)


    def setFullScreenMainWindow(self, fullScreenMainWindow):
        self.chkFullScreenMainWindow.setChecked(fullScreenMainWindow)


    def setUseCustomFont(self, useCustomFont):
        self.chkUseCustomFont.setChecked(useCustomFont)


    def setFont(self, font):
        self.cmbFont.setCurrentFont(font)
        self.edtFontSize.setValue(font.pointSize())


    def style(self):
        return str(self.cmbStyle.currentText())


    def standardPalette(self):
        return self.chkStandartPalette.isChecked()


    def maximizeMainWindow(self):
        return self.chkMaximizeMainWindow.isChecked()


    def fullScreenMainWindow(self):
        return self.chkFullScreenMainWindow.isChecked()


    def useCustomFont(self):
        return self.chkUseCustomFont.isChecked()


    def font(self):
        result = self.cmbFont.currentFont()
        result.setPointSize(self.edtFontSize.value())
        return result

